//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcBinaryFileWriter.h,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2006/01/11 19:07:06 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_BINARYFILEWRITER_H__
#define __MXCPC_BINARYFILEWRITER_H__



#include <mxcpcByteStreamReceiver.h>

#include <cstdio>



//! Byte stream receiver writing to a binary file.
/*!
 *  \ingroup mxcpc_core
 *
 *  If invoked by specifying a filename to the constructor, the respective file
 *  is automatically opened for writing. It is also automatically closed again
 *  when the binary file writer is deleted later.
 *
 *  If, on the other hand, the writer is invoked by specifying a 
 *  <tt>POSIX</tt> file descriptor to the constructor, the file descriptor is 
 *  used instead. Note that in this case the corresponing file is <b>not 
 *  closed</b> upon writer destruction.
 */
class mxcpcBinaryFileWriter : public mxcpcByteStreamReceiver {

 private:
  int OutFile;
  bool CloseFileUponDeletion;

 protected:
  bool ErrorEncountered;
  
  // only used on WINDOWS
 private:
  int RestoreMode;
  
 public:
  mxcpcBinaryFileWriter(const char *filename);
  mxcpcBinaryFileWriter(int file_descriptor);
  ~mxcpcBinaryFileWriter();

 public:
  //! (Re)implemented.
  void receiveStreamBytes(const mxcpc::u8 *bytes, int byte_num);
};



#endif   // __MXCPC_BINARYFILEWRITER_H__

