//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcBufferedMxPEGDecoderBackEnd.h,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2006/01/11 19:07:06 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_BUFFEREDMXPEGDECODERBACKEND_H__
#define __MXCPC_BUFFEREDMXPEGDECODERBACKEND_H__


#include <mxcpcMxPEGDecoderBackEnd.h>



//! Baseclass to <tt>MxPEG</tt> decoder backends internally buffering entire
//! RGB frames.
/*!
 *  \ingroup mxcpc_core
 */
class mxcpcBufferedMxPEGDecoderBackEnd : public mxcpcMxPEGDecoderBackEnd {

 protected:
  int Width, Height;
  int TileNumX, TileNumY;
  mxcpc::u32 *PixelBuffer;
  int PixelBufferOffset;
  
 private:
  mxcpc::u32 DummyTilePixelBuffer[16*16*3/4];
  
 public:
  mxcpcBufferedMxPEGDecoderBackEnd();
  ~mxcpcBufferedMxPEGDecoderBackEnd();
  
 public:
  //! (Re)implemented.
  void videoResolutionChanged(int width, int height);
  //! (Re)implemented.
  void provideVideoTilePixelTarget(int tile_x, int tile_y,
                                   mxcpc::u32 **target_ptr,
                                   int *row_stepping_ptr);   
};



#endif   // __MXCPC_BUFFEREDMXPEGDECODERBACKEND_H__

