//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcCameraLiveMxPEGFastStreamPOSIX.h,v $
//       ///       XXX       ///     $Revision: 1.3 $
//      ///      XXX XXX      ///     $Date: 2005/12/09 15:33:45 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_CAMERALIVEMXPEGFASTSTREAMPOSIX_H__
#define __MXCPC_CAMERALIVEMXPEGFASTSTREAMPOSIX_H__



#include <mxcpcCameraLiveMxPEGFastStream.h>
#include <mxcpcIPAddress.h>



//! Low-level camera faststream access implementation directly using POSIX 
//! socket I/O.
/*!
 *  \ingroup mxcpc_core
 */
class mxcpcCameraLiveMxPEGFastStreamPOSIX 
        : public mxcpcCameraLiveMxPEGFastStream {

 private:
  int Socket;
        
 public:
  mxcpcCameraLiveMxPEGFastStreamPOSIX(int ip1, int ip2, int ip3, int ip4, 
                                      int port,
                                      int fps = 4,
                                      bool asynchronous = true);
  mxcpcCameraLiveMxPEGFastStreamPOSIX(const mxcpcIPAddress& camera_ip, 
                                      int port,
                                      float fps = 4.0,
                                      bool asynchronous = true);
 private:
  void constructCommonStuff(const mxcpcIPAddress& camera_ip, 
                            int port,
                            float fps,
                            bool asynchronous = true);
 public:
  ~mxcpcCameraLiveMxPEGFastStreamPOSIX();
  
 public:
  //! Reimplemented.
  int fetchBytes(unsigned char *buffer, int num);
};



#endif   // __MXCPC_CAMERALIVEMXPEGFASTSTREAMPOSIX_H__
