//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFramewiseMxPEGScanToJPEGConverter.h,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/12/14 10:38:52 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTER_H__
#define __MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTER_H__



#include <mxcpcFramewiseMxPEGScanDecoder.h>



class mxcpcJPEGReceiver;



//! Instead of a regular scan decoder, a scan-to-JPEG converter can be plugged
//! into an mxcpcFramewiseMxPEGDecoder - bypassing conversion to and from RGB
//! and thus optimizing conversion performance as well as image quality of the
//! generated JPEG images.
/*!
 *  \ingroup mxcpc_core
 *
 *  Since the regular decoder backend is somewhat bypassed, in most cases you 
 *  will simply install an mxcpcDefaultMxPEGDecoderBackEnd with your decoder
 *  when using a scan-to-JPEG converter.
 */
class mxcpcFramewiseMxPEGScanToJPEGConverter 
: public mxcpcFramewiseMxPEGScanDecoder {
 
 protected:
  mxcpcJPEGReceiver *Receiver;
 
 public:
  //! The converter assumes ownership over the JPEG receiver.
  mxcpcFramewiseMxPEGScanToJPEGConverter(mxcpcJPEGReceiver *receiver);
  ~mxcpcFramewiseMxPEGScanToJPEGConverter();
};



#endif   // __MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTER_H__
