//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcJPEGReceiver.h,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/12/14 10:38:52 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_JPEGRECEIVER_H__
#define __MXCPC_JPEGRECEIVER_H__



#include <mxcpc_namespace.h>



//! Interface to all classes capable of processing multiple frames of binary
//! JPEG data.
/*!
 *  \ingroup mxcpc_core
 *
 *  For instance, JPEG receivers can be plugged into an 
 *  mxcpcFramewiseMxPEGScanToJPEGConverter.
 */
class mxcpcJPEGReceiver {

 public:
  virtual ~mxcpcJPEGReceiver();

 public:
  //! To inform the receiver that a new frame (JPEG image) begins.
  virtual void beginFrame(void) = 0;
  //! To inform the receiver that the current frame (JPEG image) is finished.
  virtual void endFrame(void) = 0;
  //! Used to pump JPEG bytes into the receiver. The binary data has to be 
  //! copied by the receiver.
  virtual void receiveJPEGBytes(const mxcpc::u8 *buffer, int num) = 0;
};



#endif   // __MXCPC_JPEGRECEIVER_H__

