//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcJPEGSequenceWriter.h,v $
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/12/14 10:38:52 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_JPEGSEQUENCEWRITER_H__
#define __MXCPC_JPEGSEQUENCEWRITER_H__



#include <mxcpcJPEGReceiver.h>

#include <cstdio>



//! Writes out a sequence of individual <tt>JPEG</tt>-files.
/*!
 *  \ingroup mxcpc_core
 *
 *  The individual JPEG files generated by the writer will be named using the
 *  filename prefix specified to the constructor and an appended sequence
 *  number.
 */
class mxcpcJPEGSequenceWriter : public mxcpcJPEGReceiver {

 private:
  char *FileNamePrefix;
  char *FileName;
  std::FILE *OutFile;
  int FrameNum;
  bool ErrorEncountered;
  
 public:
  //! The filename prefix will be copied.
  mxcpcJPEGSequenceWriter(const char *filename_prefix);
  ~mxcpcJPEGSequenceWriter();
 
 public:
  //! (Re)implemented.
  void beginFrame(void);
  //! (Re)implemented.
  void endFrame(void);
  //! (Re)implemented.
  void receiveJPEGBytes(const mxcpc::u8 *buffer, int num);
};



#endif   // __MXCPC_JPEGSEQUENCEWRITER_H__
