//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcStreamDecoder.h,v $
//       ///       XXX       ///     $Revision: 1.4 $
//      ///      XXX XXX      ///     $Date: 2005/12/12 19:29:16 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_STREAMDECODER_H__
#define __MXCPC_STREAMDECODER_H__



class mxcpcStreamSource;



//! Interface to all stream decoders.
/*!
 *  \ingroup mxcpc_core
 */
class mxcpcStreamDecoder {

 protected:
  mxcpcStreamSource *StreamSource;

 public:
  //! The stream decoder assumes ownership over the stream source object.
  /*!
   *  Thus, deleting the decoder results in disconnecting from the stream
   *  source.
   */
  mxcpcStreamDecoder(mxcpcStreamSource *source);
  virtual ~mxcpcStreamDecoder();
   
 public:
  //! Decodes at most <tt>num</tt> bytes of raw stream data, and returns 
  //! the number of bytes actually decoded.
  virtual int decode(int num) = 0;
  //! Returns whether or not the decoder's stream source is still operational
  //! ("up")
  bool sourceStillUp(void);
};



#endif   // __MXCPC_STREAMDECODER_H__
