//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcTime.h,v $
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2006/01/16 15:37:00 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_TIME_H__
#define __MXCPC_TIME_H__



#include <sys/time.h>



//! Measures time in milliseconds.
/*!
 *  \ingroup mxcpc_core
 */
class mxcpcTime {

 private:
  //! Only used on UNIX. 
  struct timeval BaseTime;
  //! Only used on WINDOWS
  unsigned long BaseTicks;
  
 public:
  mxcpcTime();
  
 public:
  //! Sets the base time to the current time.
  void setBaseTime(void);
  //! Returns the number of milliseconds elapsed since the last call to 
  //! elapsed() or setBaseTime().
  int elapsed(void);
};



#endif   // __MXCPC_TIME_H__

