//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpc_mxpeg_namespace.h,v $
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/12/07 10:38:54 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_MXPEG_NAMESPACE_H__
#define __MXCPC_MXPEG_NAMESPACE_H__



#include <mxcpc_namespace.h>



//! Type stuff describing bits and pieces of the <tt>MxPEG</tt> interchange
//! format.
/*!
 *  \ingroup mxcpc_core
 */
namespace mxcpc_mxpeg {

  const mxcpc::u8 MarkerId_SOI  = 0xd8;
  const mxcpc::u8 MarkerId_APP0 = 0xe0;
  const mxcpc::u8 MarkerId_DQT  = 0xdb;
  const mxcpc::u8 MarkerId_SOF0 = 0xc0;
  const mxcpc::u8 MarkerId_DHT  = 0xc4;
  const mxcpc::u8 MarkerId_SOS  = 0xda;
  const mxcpc::u8 MarkerId_EOI  = 0xd9;
  
   //! Assimilated from MxPEG Viewer (Codec2.h) 
  typedef struct {
    mxcpc::u8 ff;               // Marker-leadin
    mxcpc::u8 app0_marker;      // APP0-Marker
    mxcpc::u8 len_hi, len_lo;   // Length of APP0 block (2 bytes)
    char id[5];                 // Block ID (4 bytes - ASCII "JFIF" + \0)
    mxcpc::u8 major_vers, minor_vers; // Version Major, Minor (2 bytes - major first)
    mxcpc::u8 units;            // Units (1 byte - 0x00 = none, 0x01 = inch, 0x02 = cm)
    mxcpc::u8 xdpu_hi, xdpu_lo; // Xdpu (2 bytes - dots per unit horizontal)
    mxcpc::u8 ydpu_hi, ydpu_lo; // Ydpu (2 bytes - dots per unit vertical)
    mxcpc::u8 thumbnail_x;      // Thumbnail X size (1 byte)
    mxcpc::u8 thumbnail_y;      // Thumbnail Y size (1 byte)
  } __attribute__ ((packed))
    APP0;   

  //! Assimilated from MxPEG Viewer (Codec2.h) 
  typedef struct {
    mxcpc::u8 ff;        
    mxcpc::u8 marker;           
    mxcpc::u8 len_hi, len_lo;   
    mxcpc::u8 data_precision;   
    mxcpc::u8 y_sz_hi, y_sz_lo; 
    mxcpc::u8 x_sz_hi, x_sz_lo; 
    mxcpc::u8 num_components;   
    struct {  
      mxcpc::u8 component_id; 
      mxcpc::u8 sampl_fact;   
      mxcpc::u8 quant_tbl_no; 
    } __attribute__ ((packed))
      components[3];
  } __attribute__ ((packed))
    SOF0; 
    
  //! Assimilated from MxPEG Viewer (Codec2.h) 
  typedef struct {
    mxcpc::u8 ff;
    mxcpc::u8 sos_marker;
    mxcpc::u8 sz_hi;
    mxcpc::u8 sz_lo;
    mxcpc::u8 comps_in_scan;
    struct {
      mxcpc::u8 comp_id;
      mxcpc::u8 td_ta;
    } __attribute__ ((packed))
      components[3];
    mxcpc::u8 Ss;
    mxcpc::u8 Se;
    mxcpc::u8 Ah_Al;
  } __attribute__ ((packed))
    SOS;
   
};



#endif   // __MXCPC_MXPEG_NAMESPACE_H__

