//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcBinaryFileWriter.cpp,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2006/01/11 19:07:06 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcBinaryFileWriter.h>

#include <unistd.h>
#include <fcntl.h>



mxcpcBinaryFileWriter::mxcpcBinaryFileWriter(const char *filename) {

  OutFile = open(filename, 
                 O_CREAT | O_WRONLY | O_TRUNC,
                 S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);
                                     
  if(OutFile != -1) {
    CloseFileUponDeletion = true;
    ErrorEncountered = false;
  }
  else {
    CloseFileUponDeletion = false;
    ErrorEncountered = true;
  }
}


mxcpcBinaryFileWriter::mxcpcBinaryFileWriter(int file_descriptor) {

  OutFile = file_descriptor;
  
  CloseFileUponDeletion = false;
  ErrorEncountered = false;
}


mxcpcBinaryFileWriter::~mxcpcBinaryFileWriter() {
  
  if(CloseFileUponDeletion) close(OutFile);
}



void mxcpcBinaryFileWriter::receiveStreamBytes(const mxcpc::u8 *bytes, 
                                               int byte_num)           {

  int written, to_write;
   
  if(ErrorEncountered || (OutFile < 0)) return;
  
  // have to do it tricky to properly handle short writes...
  to_write = byte_num;
  while(to_write > 0) { 
  
    written = write(OutFile, bytes, to_write);
    if(written == -1) {
      ErrorEncountered = true;
      break;
    }
    
    to_write -= written;
    bytes += written;
  }
}

