//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcBufferedMxPEGDecoderBackEnd.cpp,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2006/01/11 19:07:06 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcBufferedMxPEGDecoderBackEnd.h>

#include <cstdio>
#include <memory>



mxcpcBufferedMxPEGDecoderBackEnd::mxcpcBufferedMxPEGDecoderBackEnd() {
  
  Width = Height = 0;
  TileNumX = TileNumY = 0;
  
  PixelBuffer = 0;
  PixelBufferOffset = 0;
}


mxcpcBufferedMxPEGDecoderBackEnd::~mxcpcBufferedMxPEGDecoderBackEnd() {

  delete[] PixelBuffer;
}



void mxcpcBufferedMxPEGDecoderBackEnd::videoResolutionChanged(int width, 
                                                              int height) {

  int tile_num_x, 
      tile_num_y;
  char txt[100];
  int unused_line_num;
        
  delete[] PixelBuffer;
  
  try {
    
      tile_num_x = width/16;
      if(width % 16) tile_num_x++;
      tile_num_y = height/16;
      if(height % 16) tile_num_y++;
         
      PixelBuffer = new mxcpc::u32[tile_num_x*tile_num_y * 16*16*3/4];
      unused_line_num = height % 16;
      if(unused_line_num)
       PixelBufferOffset = unused_line_num * (tile_num_x * 3 * 16/4); 
      else
       PixelBufferOffset = 0;
      
      Width  = width;
      Height = height;
      
      TileNumX = tile_num_x;
      TileNumY = tile_num_y;
      
      std::sprintf(txt, "mxcpcBufferedMxPEGDecoderBackEnd : "
                        "switched video resolution to "
                        "%dx%d",
                   width, height);
      mxcpc::sendStatusMsg(txt);
      
  } catch(std::bad_alloc) {
        
      PixelBuffer = 0;
      PixelBufferOffset = 0;
      Width = Height = 0;
      TileNumX = TileNumY = 0;
      
      std::sprintf(txt, "mxcpcBufferedMxPEGDecoderBackEnd : "
                        "!!! failed to switch video reolution to "
                        "%dx%d !!!",
                   width, height);
      mxcpc::sendStatusMsg(txt);
      
      errorEncountered();
  }
}


void mxcpcBufferedMxPEGDecoderBackEnd
      ::provideVideoTilePixelTarget(int tile_x, int tile_y,
                                    mxcpc::u32 **target_ptr,
                                    int *row_stepping_ptr)   {
   
  int rowsize;
                                                                     
  if(!PixelBuffer) {
  
    *target_ptr       = DummyTilePixelBuffer;
    *row_stepping_ptr = 0;
  }
  else {
  
    rowsize = 16*3/4;   // in u32 units
 
    *target_ptr       = PixelBuffer 
                         + (((TileNumY - 1 - tile_y)*16 + 15)*TileNumX + tile_x) * rowsize;
    *row_stepping_ptr = -(1 + TileNumX) * rowsize; 
  }                                   
}

