//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcDefaultMxPEGDecoderBackEnd.cpp,v $
//       ///       XXX       ///     $Revision: 1.2 $
//      ///      XXX XXX      ///     $Date: 2005/12/07 10:38:54 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcDefaultMxPEGDecoderBackEnd.h>
#include <mxcpc_namespace.h>

#include <cstdlib>
#include <cstdio>



mxcpcDefaultMxPEGDecoderBackEnd::mxcpcDefaultMxPEGDecoderBackEnd() {

  ReceivedFrames = 0;
  TileNum = 0;
  
  ErrorEncountered = false;
}



void mxcpcDefaultMxPEGDecoderBackEnd::videoResolutionChanged(int width, 
                                                             int height) {
                                                             
  char txt[100];
  
  std::sprintf(txt, "mxcpcDefaultMxPEGDecoderBackEnd : "
                    "video resolution changed to %dx%d.", width, height);
  mxcpc::sendStatusMsg(txt);
}


void mxcpcDefaultMxPEGDecoderBackEnd::errorEncountered(void) {

  ErrorEncountered = true;
}


void mxcpcDefaultMxPEGDecoderBackEnd::frameComplete(void) {

  char txt[100];

  ReceivedFrames++;
 
  if(!ErrorEncountered) 
    std::sprintf(txt, "mxcpcDefaultMxPEGDecoderBackEnd : "
                      "------ video frame #%d with %d tiles OK ------", 
                 ReceivedFrames, TileNum);
  else 
    std::sprintf(txt, "@@@@@@@@ mxcpcDefaultMxPEGDecoderBackEnd : CORRUPT FRAME");
  
  mxcpc::sendStatusMsg(txt);
    
           
  TileNum = 0;
  ErrorEncountered = false;
}


void mxcpcDefaultMxPEGDecoderBackEnd::provideVideoTilePixelTarget(
                                       int tile_x, int tile_y,
                                       mxcpc::u32 **target_ptr,
                                       int *row_stepping_ptr)      {

  *target_ptr       = (mxcpc::u32 *)TilePixelBuffer;
  *row_stepping_ptr = 0;                                       
}

                                                             
void mxcpcDefaultMxPEGDecoderBackEnd::videoTileReceived(void) {

  TileNum++;
}


int mxcpcDefaultMxPEGDecoderBackEnd::getDecodedFramesNum(void) {

  return(ReceivedFrames);
}

