//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly.cpp,v $
//       ///       XXX       ///     $Revision: 1.4 $
//      ///      XXX XXX      ///     $Date: 2005/12/20 16:41:55 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly.h>
#include <mxcpcMxPEGDecoderBackEnd.h>
#include <mxcpcJPEGReceiver.h>
#include <mxcpc_exceptions.h>

#include <memory>



const int mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::ZigZagMap[64] = {  
                                                  0,  1,  8, 16,  9,  2,  3, 10, 
                                                 17, 24, 32, 25, 18, 11,  4,  5,
                                                 12, 19, 26, 33, 40, 48, 41, 34, 
                                                 27, 20, 13,  6,  7, 14, 21, 28,
                                                 35, 42, 49, 56, 57, 50, 43, 36,
                                                 29, 22, 15, 23, 30, 37, 44, 51, 
                                                 58, 59, 52, 45, 38, 31, 39, 46, 
                                                 53, 60, 61, 54, 47, 55, 62, 63 
                                                };

const unsigned char mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
                     ::ZigZag_StoreMap[64] = {
                                                  0,  1,  5,  6, 14, 15, 27, 28,
                                                  2,  4,  7, 13, 16, 26, 29, 42,
                                                  3,  8, 12, 17, 25, 30, 41, 43,
                                                  9, 11, 18, 24, 31, 40, 44, 53,
                                                 10, 19, 23, 32, 39, 45, 52, 54,
                                                 20, 22, 33, 38, 46, 51, 55, 60,
                                                 21, 34, 37, 47, 50, 56, 59, 61,
                                                 35, 36, 48, 49, 57, 58, 62, 63
                                             };

const mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::HuffCompDC
       mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::HuffTbl_Y_UV_DC[2] ={
  { 
    { 0, 1, 5, 1, 1, 1, 1, 1, 1, 0,  0,  0, 0, 0, 0, 0 }, 
     /*!< dc-bits[1..16]: index 0 is missing, 1..16 only ! */
    { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 }, 						
     /*!< dc-val[0..11]: */   
  },
  { 
    { 0, 3, 1, 1, 1, 1, 1, 1, 1, 1,  1,  0, 0, 0, 0, 0 }, 
     /*!< bits_dc[1..16]: index 0 is missing, 1..16 only ! */
    { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 },
     /*!< val_dc[0..11]: */   
  }
};
	
const mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::HuffCompAC 
       mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::HuffTbl_Y_UV_AC[2] ={
  { 
    { 0, 2, 1, 3, 3, 2, 4, 3, 5, 5, 4, 4, 0, 0, 1, 0x7d }, 
    { 0x01, 0x02, 0x03, 0x00, 0x04, 0x11, 0x05, 0x12, 
      0x21, 0x31, 0x41, 0x06, 0x13, 0x51, 0x61, 0x07,
      0x22, 0x71, 0x14, 0x32, 0x81, 0x91, 0xa1, 0x08,
      0x23, 0x42, 0xb1, 0xc1, 0x15, 0x52, 0xd1, 0xf0,      
      0x24, 0x33, 0x62, 0x72, 0x82, 0x09, 0x0a, 0x16,
      0x17, 0x18, 0x19, 0x1a, 0x25, 0x26, 0x27, 0x28,
      0x29, 0x2a, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
      0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49,
      0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59,
      0x5a, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69,
      0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79,
      0x7a, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,      
      0x8a, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98,
      0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7,
      0xa8, 0xa9, 0xaa, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6,
      0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3, 0xc4, 0xc5,	      
      0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2, 0xd3, 0xd4,
      0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda, 0xe1, 0xe2,
      0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9, 0xea,
      0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8,      
      0xf9, 0xfa 
    }, 						
  },
  { 
    { 0, 2, 1, 2, 4, 4, 3, 4, 7, 5, 4, 4, 0, 1, 2, 0x77 },
    { 0x00, 0x01, 0x02, 0x03, 0x11, 0x04, 0x05, 0x21, 
      0x31, 0x06, 0x12, 0x41, 0x51, 0x07, 0x61, 0x71,
      0x13, 0x22, 0x32, 0x81, 0x08, 0x14, 0x42, 0x91,
      0xa1, 0xb1, 0xc1, 0x09, 0x23, 0x33, 0x52, 0xf0,
      0x15, 0x62, 0x72, 0xd1, 0x0a, 0x16, 0x24, 0x34,
      0xe1, 0x25, 0xf1, 0x17, 0x18, 0x19, 0x1a, 0x26,
      0x27, 0x28, 0x29, 0x2a, 0x35, 0x36, 0x37, 0x38,
      0x39, 0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48,
      0x49, 0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
      0x59, 0x5a, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68,
      0x69, 0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
      0x79, 0x7a, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
      0x88, 0x89, 0x8a, 0x92, 0x93, 0x94, 0x95, 0x96,
      0x97, 0x98, 0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5,
      0xa6, 0xa7, 0xa8, 0xa9, 0xaa, 0xb2, 0xb3, 0xb4,
      0xb5, 0xb6, 0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3,
      0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2,
      0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda,
      0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
      0xea, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8,
      0xf9, 0xfa 
    }, 						
  } 
};

mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::FoldedHuffTbl_DC_AC 
 mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::Huff_Y_UV[2];
																																						
mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::HuffmanBufferStateStructure 
 mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::HuffmanBufferState;
	
																
mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
 ::mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly(
    mxcpcJPEGReceiver *receiver
   ) : mxcpcFramewiseMxPEGScanToJPEGConverter(receiver) {       
	
  char txt[100];
	
  // Init the encoder buffer structure ...
  HuffmanEncoderBuffer 
   = new mxcpc::u8[MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTER_BITSTREAM_BUFFSIZE];
  initHuffmanEncoderBufferState();
	
  // Create encode huffman tables ...
  calcFoldedHuffTables();
	 
  // Build Huffman Tree from Huffman tables. The tables are defined 
  // in mxcpcFramewiseMxPEGScanDecoder
  HuffmanTree_Y_DC  = 0, 
  HuffmanTree_Y_AC  = 0;         
  HuffmanTree_UV_DC = 0, 
  HuffmanTree_UV_AC = 0;
	
  try {
  
    HuffmanTree_Y_DC = new mxcpcHuffmanTree();
    if(HuffmanTree_Y_DC->configureFromTable(DefaultHuffmanTable_Y_DC))
      throw mxcpcDidntWorkOutException();
    HuffmanTree_Y_AC = new mxcpcHuffmanTree();
    if(HuffmanTree_Y_AC->configureFromTable(DefaultHuffmanTable_Y_AC))
      throw mxcpcDidntWorkOutException();
    HuffmanTree_UV_DC = new mxcpcHuffmanTree();
    if(HuffmanTree_UV_DC->configureFromTable(DefaultHuffmanTable_UV_DC))
      throw mxcpcDidntWorkOutException();
    HuffmanTree_UV_AC = new mxcpcHuffmanTree();
    if(HuffmanTree_UV_AC->configureFromTable(DefaultHuffmanTable_UV_AC))
      throw mxcpcDidntWorkOutException();  
 		
  } catch(std::exception &e) {
  		
      MXCPC_RETHROW_UNHANDLED_EXCEPTION(e);
    
      delete HuffmanTree_Y_DC; 
      delete HuffmanTree_Y_AC;         
      delete HuffmanTree_UV_DC; 
      delete HuffmanTree_UV_AC;
      
      throw;
    }
  
  // Init Quantization tables ...
  int i;
  for(i = 0; i < 64; i++) {
    QuantizationTable_Y[i]  = 0;
    QuantizationTable_UV[i] = 0;
  }
  
  std::sprintf(txt, "symbols in Y/DC Huffman table : %d", 
               HuffmanTree_Y_DC->countLeaves());
  mxcpc::sendStatusMsg(txt, this);
  std::sprintf(txt, "symbols in Y/AC Huffman table : %d", 
               HuffmanTree_Y_AC->countLeaves());
  mxcpc::sendStatusMsg(txt, this);
  std::sprintf(txt, "symbols in UV/DC Huffman table : %d", 
               HuffmanTree_UV_DC->countLeaves());
  mxcpc::sendStatusMsg(txt, this);
  std::sprintf(txt, "symbols in UV/AC Huffman table : %d", 
               HuffmanTree_UV_AC->countLeaves());
  mxcpc::sendStatusMsg(txt, this);
																					 
  // Init member var ...
  CoeffBuffer = 0;           // This buffer holds the DCT-JPEG image
  TileNumX = TileNumY = 0;
  
  FramesProcessed = 0;
    
  // init APP0 - taken from Klaus' jp-hdr.c (20050422)...
  APP0_Block.ff          = 0xff;
  APP0_Block.app0_marker = mxcpc_mxpeg::MarkerId_APP0;
  APP0_Block.len_hi      = (sizeof(mxcpc_mxpeg::APP0) - 2) / 256;
  APP0_Block.len_lo      = (sizeof(mxcpc_mxpeg::APP0) - 2) % 256;
  std::strcpy(APP0_Block.id, "JFIF"); 
  APP0_Block.major_vers  = 0x01; 
  APP0_Block.minor_vers  = 0x01;
  APP0_Block.units       = 0x00;
  APP0_Block.xdpu_hi     = 0;
  APP0_Block.xdpu_lo     = 1;
  APP0_Block.ydpu_hi     = 0;
  APP0_Block.ydpu_lo     = 1;
  APP0_Block.thumbnail_x = 0;
  APP0_Block.thumbnail_y = 0;
  
  // init SOF0, image size is zeroed out...
  SOF0_Block.ff                         = 0xff;
  SOF0_Block.marker                     = mxcpc_mxpeg::MarkerId_SOF0;
  SOF0_Block.len_hi                     = (sizeof(mxcpc_mxpeg::SOF0) - 2) / 256;
  SOF0_Block.len_lo                     = (sizeof(mxcpc_mxpeg::SOF0) - 2) % 256;
  SOF0_Block.data_precision             = 0x08;
  SOF0_Block.y_sz_hi                    = 0;
  SOF0_Block.y_sz_lo                    = 0;
  SOF0_Block.x_sz_hi                    = 0;
  SOF0_Block.x_sz_lo                    = 0;
  SOF0_Block.num_components             = 3;
  SOF0_Block.components[0].component_id = 1;   // Y
  SOF0_Block.components[0].sampl_fact   = 0x22;
  SOF0_Block.components[0].quant_tbl_no = 0;
  SOF0_Block.components[1].component_id = 2;   // U
  SOF0_Block.components[1].sampl_fact   = 0x11;
  SOF0_Block.components[1].quant_tbl_no = 1;
  SOF0_Block.components[2].component_id = 3;   // V
  SOF0_Block.components[2].sampl_fact   = 0x11;
  SOF0_Block.components[2].quant_tbl_no = 1;
  
  // init SOF0, image size is zeroed out...
  SOS_Block.ff                    = 0xff;
  SOS_Block.sos_marker            = mxcpc_mxpeg::MarkerId_SOS;
  SOS_Block.sz_hi                 = (sizeof(mxcpc_mxpeg::SOS) - 2) / 256;
  SOS_Block.sz_lo                 = (sizeof(mxcpc_mxpeg::SOS) - 2) % 256;
  SOS_Block.comps_in_scan         = 3;
  SOS_Block.components[0].comp_id = 1;
  SOS_Block.components[0].td_ta   = 0x00;
  SOS_Block.components[1].comp_id = 2;
  SOS_Block.components[1].td_ta   = 0x11;
  SOS_Block.components[2].comp_id = 3;
  SOS_Block.components[2].td_ta   = 0x11;
  SOS_Block.Ss                    = 0x00;
  SOS_Block.Se                    = 0x3f;
  SOS_Block.Ah_Al                 = 0x00;
}   


mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
 ::~mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly() {

  delete HuffmanTree_Y_DC; 
  delete HuffmanTree_Y_AC;         
  delete HuffmanTree_UV_DC; 
  delete HuffmanTree_UV_AC;

  delete[] CoeffBuffer;
  delete[] HuffmanEncoderBuffer;	
}   



const char *mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
            ::getAccelerationTypeString(void) {
                    
  return("none");
}


void mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
      ::setYQuantizationTable(unsigned char *data_bytes) {

  int i;
  
  for(i = 0; i < 64; i++) QuantizationTable_Y[ZigZagMap[i]] = *data_bytes++;
}

 
void mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
      ::setUVQuantizationTable(unsigned char *data_bytes) {

  int i;

  for(i = 0; i < 64; i++) QuantizationTable_UV[ZigZagMap[i]] = *data_bytes++;
}


void mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
      ::performScanSweep(mxcpcFramewiseMxPEGDecoder::UndecodedFrameDescriptor 
                          *frame_descriptor)                                  {
                            
  // init local data and lookup tables...
  const mxcpcHuffmanTree::Node *Huffman_DC_Roots[6] = { 
                                                    HuffmanTree_Y_DC->getRoot(),
                                                    HuffmanTree_Y_DC->getRoot(),
                                                    HuffmanTree_Y_DC->getRoot(),
                                                    HuffmanTree_Y_DC->getRoot(),
                                                    HuffmanTree_UV_DC->getRoot(),
                                                    HuffmanTree_UV_DC->getRoot()
                                                   },
                               *Huffman_AC_Roots[6] = { 
                                                    HuffmanTree_Y_AC->getRoot(),
                                                    HuffmanTree_Y_AC->getRoot(),
                                                    HuffmanTree_Y_AC->getRoot(),
                                                    HuffmanTree_Y_AC->getRoot(),
                                                    HuffmanTree_UV_AC->getRoot(),
                                                    HuffmanTree_UV_AC->getRoot()
                                                   };
                                                   
  // remaining local data...
  
  bool use_bitmask;
  int tilebits_left;
  unsigned char *tilebit_ptr, tilebit_mask;
  int x, y;
  bool next_tile_right_here;
  int tiles_to_write;
	
  // needed for Huffman decoding
  const mxcpcHuffmanTree::Node *huffman_leaf_node;												                          
  int additional_bit_num;
  int ac_coeffs_needed;
  int ac_coeffs_to_output;
	
  // For handling the predictively coded dc ... 
  mxcpc::s16 dc_coeffs[3] = { 0, 0, 0};
  mxcpc::s16 *dc_coeff_ptrs[6] = { &dc_coeffs[0],
                                   &dc_coeffs[0],
                                   &dc_coeffs[0],
                                   &dc_coeffs[0],
                                   &dc_coeffs[1],
                                   &dc_coeffs[2]
                                 };

	
  int coeff_i;
	
  mxcpc::s16 *sub_mcu_coeffs;
  mxcpc::u8 quantization_table_to_write[64];
  mxcpc::s16 *quant_coeff;
  const unsigned char *huffman_table_to_write;
  int                  huffman_table_to_write_size;
  
  int i, j;
  
  mxcpc::u8 write_buffer[10];
	
  // points to the current Tile (6*64 ~> YYYYUV )
  mxcpc::s16 *coeff_buffer=0;

  // guard against missing backend
  if(!BackEnd) return;
  
  // check coeff buffer and its dimensions...
  if(   (frame_descriptor->TileNumX != TileNumX)
     || (frame_descriptor->TileNumY != TileNumY)) {
  
    delete[] CoeffBuffer;
    
    try {
    
      CoeffBuffer = new mxcpc::s16[frame_descriptor->TileNumX 
                                    * frame_descriptor->TileNumY
                  		    * 6 * 64
                                  ];
												
      TileNumX = frame_descriptor->TileNumX;
      TileNumY = frame_descriptor->TileNumY;
      
      mxcpc::sendStatusMsg("JPG converter : reallocated coeff buffer");
                                
    } catch(std::bad_alloc) {
      	
        mxcpc::sendStatusMsg("JPG converter : "
                             "reallocation of coeff buffer failed!");	
			
        CoeffBuffer = 0;
        TileNumX = TileNumY = 0;
      }
  }  
  
  if(!CoeffBuffer) {
    mxcpc::sendStatusMsg("JPG converter : CoeffBuffer == NULL!");
    BackEnd->errorEncountered();
    return;
  } 
      
    
  // decide for bitmask mode...
  CurrentScanByte = frame_descriptor->ScanBytes;
  ScanMask        = 128;
  ScanBytesLeft   = frame_descriptor->ScanLength;
  if(!CurrentScanByte || !ScanBytesLeft) {
    BackEnd->errorEncountered();
    return;
  }    
  tilebits_left = frame_descriptor->TileNumX * frame_descriptor->TileNumY;
  tilebit_ptr   = frame_descriptor->TileBits;
  tilebit_mask  = 128;
  x = -1;
  y = 0;
  next_tile_right_here = true;   // default for bitmask-less mode
  if(tilebit_ptr) 
    use_bitmask = true;
  else
    use_bitmask = false;
		
    
  // iterate over all tiles (MCUs)...
  while(tilebits_left) {
  						
    // advance target tile coordinates...
    x++;
    if(x == frame_descriptor->TileNumX) {
      x = 0;
      y++;
    }
  
    // if in bitmask mode, consume and honor current tile bit...
    if(use_bitmask) {
      next_tile_right_here = (*tilebit_ptr & tilebit_mask) != 0;
      tilebit_mask /= 2;
      if(!tilebit_mask) {
        tilebit_mask = 128;
        tilebit_ptr++;
      }
    }
		

   
    if(next_tile_right_here) {   // decode tile...
      
      // iterate over the 6 sub-MCUs (Y,Y,Y,Y,U,V)...
      for(i = 0; i < 6; i++) {
       		
	coeff_buffer 
         = &CoeffBuffer[y * TileNumX * 6*64  +  x * 6*64  +  i * 64];
												
	// --- decode the DC coeff... ---
        
        // recognize Huffman codeword...
        huffman_leaf_node = consumeHuffmanCodeword(Huffman_DC_Roots[i]);
								
        if(!huffman_leaf_node) {
					
          BackEnd->errorEncountered();
	  mxcpc::sendStatusMsg("JPG converter : "
                               "1) huffman_leaf_node DC == NULL");
          return;
        }
 
        // deal with additional bits to be read for this coeff...
        additional_bit_num = (int)(  (unsigned int)huffman_leaf_node->Value
                                   & (unsigned int)0x0f);
        if(additional_bit_num) {
          if(consumeAdditionalBits(additional_bit_num)) {
					
            mxcpc::sendStatusMsg("JPG converter : Return val consumeAdditionalBits() == NULL");
            BackEnd->errorEncountered();
            return;
          }
          coeff_buffer[0] = CoeffInAdditionalBits;
        }
        else {
          coeff_buffer[0] = 0;
        }
        
        // do delta stuff...
        coeff_buffer[0] += *dc_coeff_ptrs[i];
        *dc_coeff_ptrs[i] = coeff_buffer[0];
        
        
        // --- decode 63 AC coeffs... ---
        coeff_i = 1;
        ac_coeffs_needed = 63;
        while(ac_coeffs_needed) {
        
          // recognize Huffman codeword...
          huffman_leaf_node = consumeHuffmanCodeword(Huffman_AC_Roots[i]);
          if(!huffman_leaf_node) {
					
	    mxcpc::sendStatusMsg("JPG converter : "
                                 "2)huffman_leaf_node AC == NULL");		
            BackEnd->errorEncountered();
            return;
          } 
          
          // check for EOB...
          if(huffman_leaf_node->Value == 0x00) {
            while(ac_coeffs_needed) {   // zero out the remaining matrix cells 
              coeff_buffer[ZigZagMap[coeff_i]] = 0;
              coeff_i++;
              ac_coeffs_needed--;
            }
            continue;   // ac_coeffs_needed is 0
          }
          
          // deal with additional bits to be read for this coeff...
          additional_bit_num = (int)(  (unsigned int)huffman_leaf_node->Value
                                     & (unsigned int)0x0f);                            
          if(additional_bit_num) {
            if(consumeAdditionalBits(additional_bit_num)) {
              mxcpc::sendStatusMsg("JPG converter : "
                                   "return val consumeAdditionalBits() == "
                                   "NULL");
              BackEnd->errorEncountered();																			
              return;
            }
          }
          else
            CoeffInAdditionalBits = 0;
          
          // deal with AC coeffs to output and check break condition...
          ac_coeffs_to_output = huffman_leaf_node->Value/16 + 1;
          if(ac_coeffs_to_output > ac_coeffs_needed) {
            mxcpc::sendStatusMsg("too many AC coeffs!");
            BackEnd->errorEncountered();
            return;
          }
          for(j = 0; j < ac_coeffs_to_output-1; j++) {   // fill zeroes...
            coeff_buffer[ZigZagMap[coeff_i]] = 0;
            coeff_i++;
          }
          coeff_buffer[ZigZagMap[coeff_i]] = CoeffInAdditionalBits;
          coeff_i++;
          if(coeff_i > 64) {
            mxcpc::sendStatusMsg("coeff buffer overflow!");
            BackEnd->errorEncountered();
            return;
          }
          
          ac_coeffs_needed -= ac_coeffs_to_output;
        }     
				
      }
					      
      // got all 6 sub-MCUs!
            
      BackEnd->videoTileReceived();
    } 
    
    tilebits_left--;
  }
  
  // ok, we've got a frame, generate some JPEG...
  
  Receiver->beginFrame();
	 
  // write SOI...
  write_buffer[0] = 0xff;
  write_buffer[1] = mxcpc_mxpeg::MarkerId_SOI;
  Receiver->receiveJPEGBytes(write_buffer, 2);
  
  // write APP0...
  Receiver->receiveJPEGBytes((mxcpc::u8 *)&APP0_Block, 
                             sizeof(mxcpc_mxpeg::APP0));
  
  // write quantization tables, Y(0) and UV(1)...
  for(i = 0; i < 2; i++) {   // got two of them 
    write_buffer[0] = 0xff;
    write_buffer[1] = mxcpc_mxpeg::MarkerId_DQT;
    write_buffer[2] = 0;
    write_buffer[3] = 67;
    write_buffer[4] = i;
    Receiver->receiveJPEGBytes(write_buffer, 5);
  
    if(!i) quant_coeff = QuantizationTable_Y;
    else   quant_coeff = QuantizationTable_UV;
    for(j = 0; j < 64; j++) 
     quantization_table_to_write[ZigZag_StoreMap[j]] 
      = ((mxcpc::u8)*quant_coeff++);
    Receiver->receiveJPEGBytes(quantization_table_to_write, 64);
  }
  
  // write SOF0...
  SOF0_Block.x_sz_hi = frame_descriptor->Width / 256;
  SOF0_Block.x_sz_lo = frame_descriptor->Width % 256;
  SOF0_Block.y_sz_hi = frame_descriptor->Height / 256;
  SOF0_Block.y_sz_lo = frame_descriptor->Height % 256;
  Receiver->receiveJPEGBytes((mxcpc::u8 *)&SOF0_Block, 
                             sizeof(mxcpc_mxpeg::SOF0));
																			 
  // write huffman tables...
  for(i = 0; i < 4; i++) {   // got four of them  
    write_buffer[0] = 0xff;
    write_buffer[1] = mxcpc_mxpeg::MarkerId_DHT;
    if(i == 0) {
      write_buffer[4] = 0x00;
      huffman_table_to_write      = DefaultHuffmanTable_Y_DC;
      huffman_table_to_write_size = DefaultHuffmanTable_Y_DC_Size;
    }
    else if(i == 1) {
      write_buffer[4] = 0x10;
      huffman_table_to_write      = DefaultHuffmanTable_Y_AC;
      huffman_table_to_write_size = DefaultHuffmanTable_Y_AC_Size;
    }
    else if(i == 2) {
      write_buffer[4] = 0x01;
      huffman_table_to_write      = DefaultHuffmanTable_UV_DC;
      huffman_table_to_write_size = DefaultHuffmanTable_UV_DC_Size;
    }
    else {
      write_buffer[4] = 0x11;
      huffman_table_to_write      = DefaultHuffmanTable_UV_AC;
      huffman_table_to_write_size = DefaultHuffmanTable_UV_AC_Size;
    }
    write_buffer[2] = (huffman_table_to_write_size + 3) / 256;
    write_buffer[3] = (huffman_table_to_write_size + 3) % 256;
    Receiver->receiveJPEGBytes(write_buffer, 5);
    Receiver->receiveJPEGBytes((mxcpc::u8 *)huffman_table_to_write, 
                               huffman_table_to_write_size);
  }  
  
  // write SOS...
  Receiver->receiveJPEGBytes((mxcpc::u8 *)&SOS_Block, 
                             sizeof(mxcpc_mxpeg::SOS));
 																		 
  // init dc_coeff_ptrs[i]
  for(i=0; i < 3; i++) dc_coeffs[i] = 0;
  dc_coeff_ptrs[0] = &dc_coeffs[0];
  dc_coeff_ptrs[1] = &dc_coeffs[0];
  dc_coeff_ptrs[2] = &dc_coeffs[0];
  dc_coeff_ptrs[3] = &dc_coeffs[0];
  dc_coeff_ptrs[4] = &dc_coeffs[1];
  dc_coeff_ptrs[5] = &dc_coeffs[2];
	
  // define huffman code table list ..
  FoldedHuffTbl_DC_AC* huff_code_table_list[6];
	
  // Y -Table ...
  huff_code_table_list[0] = &Huff_Y_UV[0]; 
  huff_code_table_list[1] = &Huff_Y_UV[0];
  huff_code_table_list[2] = &Huff_Y_UV[0]; 																		  																		 
  huff_code_table_list[3] = &Huff_Y_UV[0];
	
  // UV -Table
  huff_code_table_list[4] = &Huff_Y_UV[1]; 																		  																		 
  huff_code_table_list[5] = &Huff_Y_UV[1];
	 																		 
  // write out scan...
  sub_mcu_coeffs = CoeffBuffer;
  tiles_to_write = TileNumX * TileNumY;
	
  int nb_of_bytes_to_write = 0; 
  while(tiles_to_write) {
  
    // iterate over sub-MCUs of current tile YYYYUV ...
    for(i = 0; i < 6; i++) {
      encodeSubMCUTiles(sub_mcu_coeffs,
                        dc_coeff_ptrs[i],
                        huff_code_table_list[i],
                        &HuffmanBufferState);																							                    
      sub_mcu_coeffs += 64;
    }
  
    tiles_to_write--;
  }

  // write last byte ...	
  shutDownHuffAccu();

  // pump out data ...
  nb_of_bytes_to_write 
   = HuffmanBufferState.buf_current_w_pos - HuffmanBufferState.buf_start;
  Receiver->receiveJPEGBytes(HuffmanBufferState.buf_start, 
                             nb_of_bytes_to_write);
 
  // Reset global encoding buffer ...
  resetHuffmanEncoderBufferState();
  
  // write EOI...
  write_buffer[0] = 0xff;
  write_buffer[1] = mxcpc_mxpeg::MarkerId_EOI;
  Receiver->receiveJPEGBytes(write_buffer, 2);
   
  
  // ok, we've done it!
  Receiver->endFrame();
  
  FramesProcessed++;
}


/*! 
		Calculates huffman tables a la mobotix!
*/
void mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
      ::calcFoldedHuffTables(void){

  int y_uv;

  static int firstcall = 0;
  if (firstcall) return;

  firstcall++;

  // Generate two sets of tables, for Y and UV 
  for (y_uv = 0; y_uv < 2; y_uv++) {  
			
    /* first generate DC-table */
    generateHuffTables1(
     /* u8 * bits_tbl_off1, entries 0..15 count no. of symbols with 1..16 bits, 
        respectively */ 
     &HuffTbl_Y_UV_DC[y_uv].bits_dc[0],
     /* u8 * val_tbl,       table of symbols that need to be encoded, 
        size = sum of entries in bits_tbl_off1 */ 
     &HuffTbl_Y_UV_DC[y_uv].val_dc[0],
     /* int swap_symbol, set if the swapped symbol is used to access the generated
        folded table (for ac-coefs) */  
     0,                                 
     &Huff_Y_UV[y_uv].dc_tbl[0]
    );
	
    /* then AC-table */
    generateHuffTables1(
     /* u8 * bits_tbl_off1, entries 0..15 count no. of symbols with 1..16 bits,
        respectively */ 
     &HuffTbl_Y_UV_AC[y_uv].bits_ac[0],
     /* u8 * val_tbl, table of symbols that need to be encoded, size = sum of 
        entries in bits_tbl_off1 */ 
     &HuffTbl_Y_UV_AC[y_uv].val_ac[0],
     /* int swap_symbol, set if the swapped symbol is used to access the 
        generated folded table (for ac-coefs) */  
     1,
     /* jd_huf_code_tbl_entry_t * folded_tbl_p; */                                 
     &Huff_Y_UV[y_uv].ac_tbl[0]
    );
  }
}	


/*!   
  Generate a run-length-coded huffman-code-tree for all symbols in
  val_tabl.
 
  The huffman-codes for each symbol are stored in a "folded" table
  that can be indexed by a symbol and yields a word that contains
  the pre-shifted code in the lower 26 bits and the length of the combination 
  of the rll-coded symbol and the mantissa in the upper 5 bits

  \param bits_tbl_off1 
  Entries 0..15 count no. of symbols with 1..16 bits, respectively.
  \param val_tbl 
  Table of symbols that need to be encoded, size = sum of entries in 
  bits_tbl_off1.
  \param swap_symbol set if the swapped symbol is used to access the generated
  folded table (for ac-coefs).
*/
void mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly::generateHuffTables1(
      const mxcpc::u8 * bits_tbl_off1,  
      const mxcpc::u8 * val_tbl,   
      int swap_symbol,    
      HuffCodeTblEntry * folded_tbl_p
     )                                                                        {

  int len, codes_of_len, mantissa_len;

  int code = 0;
  for(len = 1; len <= 16; len ++) {
  
    for(codes_of_len = 1; 
        codes_of_len <= bits_tbl_off1[len - 1];
        codes_of_len++)                         {
    
      int symbol = *val_tbl++;     /* get unswapped symbol from the table in the 
                                      Jpeg-header */
      mantissa_len = symbol & 0xf; /* top nibble is run-length, 
                                      low nibble is number of significant bits
                                      in coefficient */
      if(swap_symbol) {            /* 0xRS -> 0xSR */ 
        symbol = (symbol >> 4) + ((symbol & 0xf) << 4);  
      }
      folded_tbl_p[symbol].code_msk  = code << mantissa_len;
      folded_tbl_p[symbol].fill_0bit = 0;
      folded_tbl_p[symbol].bit_len   = len + mantissa_len;
      code++;
    }
    
    code <<= 1;
  }
}


/*!
   Take care of initialisierung!
*/
void mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
      ::initHuffmanEncoderBufferState()                 {

  HuffmanBufferState.buf_start         = &HuffmanEncoderBuffer[0];
  HuffmanBufferState.buf_current_w_pos = &HuffmanEncoderBuffer[0];
  HuffmanBufferState.buf_end1
   = &HuffmanEncoderBuffer[
       MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTER_BITSTREAM_BUFFSIZE + 1
      ];
                                                                                                                                                                                
  HuffmanBufferState.huf_accu          = 0;
  HuffmanBufferState.huf_bits_used     = 0;
}


/*!
    Reset HuffmanEncoderBufferState in order to fetch next frame!
*/
void mxcpcFramewiseMxPEGScanToJPEGConverterSoftwareOnly
      ::resetHuffmanEncoderBufferState()                {

  HuffmanBufferState.buf_start         = &HuffmanEncoderBuffer[0];
  HuffmanBufferState.buf_current_w_pos = &HuffmanEncoderBuffer[0];

  HuffmanBufferState.huf_accu          = 0;
  HuffmanBufferState.huf_bits_used     = 0;
}

