//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcMJPEGWriter.cpp,v $
//       ///       XXX       ///     $Revision: 1.4 $
//      ///      XXX XXX      ///     $Date: 2006/01/11 19:07:06 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcMJPEGWriter.h>

#include <memory>
#include <cstring>



mxcpcMJPEGWriter::mxcpcMJPEGWriter(const char *filename,
                                   const char *separator)
                   : mxcpcBinaryFileWriter(filename)      {
  
  FrameNum = 0;
  
  installSeparator(separator);
}


mxcpcMJPEGWriter::mxcpcMJPEGWriter(int file_descriptor,
                                   const char *separator)
                   : mxcpcBinaryFileWriter(file_descriptor) {
  
  FrameNum = 0;
  
  installSeparator(separator);
}


void mxcpcMJPEGWriter::installSeparator(const char *separator) {

  char txt[200];
  
  if(separator) {
    try {
      Separator = new char[std::strlen(separator) + 1];
      std::strcpy(Separator, separator);
    } catch(std::bad_alloc) {
        Separator = 0;
        ErrorEncountered = true;
      }
  }
  else {
    Separator = 0;
  }
  
  if(Separator && !ErrorEncountered) {
    std::strcpy(txt, "Content-type: multipart/x-mixed-replace;boundary=\"");
    receiveJPEGBytes((mxcpc::u8 *)txt, std::strlen(txt));
    receiveJPEGBytes((mxcpc::u8 *)Separator, std::strlen(Separator));
    std::strcpy(txt, "\"\r\n");
    receiveJPEGBytes((mxcpc::u8 *)txt, std::strlen(txt)); 
  }
}


mxcpcMJPEGWriter::~mxcpcMJPEGWriter() {
  
  char txt[200];
  
  if(Separator && !ErrorEncountered) {
    std::strcpy(txt, "\r\n--");
    receiveJPEGBytes((mxcpc::u8 *)txt, std::strlen(txt));
    receiveJPEGBytes((mxcpc::u8 *)Separator, std::strlen(Separator));
    std::strcpy(txt, "--\r\n");
    receiveJPEGBytes((mxcpc::u8 *)txt, std::strlen(txt));
  }
  
  delete Separator;
}



void mxcpcMJPEGWriter::beginFrame(void) {

  char txt[200];
  
  if(Separator && !ErrorEncountered) {
    std::strcpy(txt, "\r\n--");
    receiveJPEGBytes((mxcpc::u8 *)txt, std::strlen(txt));
    receiveJPEGBytes((mxcpc::u8 *)Separator, std::strlen(Separator));
    std::strcpy(txt, "\r\nContent-type: image/jpeg\r\n\r\n");
    receiveJPEGBytes((mxcpc::u8 *)txt, std::strlen(txt));
  }
}


void mxcpcMJPEGWriter::endFrame(void) {
  
  if(ErrorEncountered) return;
  
  FrameNum++;
}
  

void mxcpcMJPEGWriter::receiveJPEGBytes(const mxcpc::u8 *buffer, 
                                        int num)                 {

  receiveStreamBytes(buffer, num);
}
