//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcTime_win.cpp,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2006/01/16 15:37:00 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



/*! 
 *  \file mxcpcTime_win.cpp
 *
 *  \brief Alternate implementation for the <tt>WINDOWS</tt> platform
 * 
 *  Differs from the original UNIX implementation in that we have to use another
 *  method for accessing the system time.
 */



#include <mxcpcTime.h>
#include <mxcpc_namespace.h>

#include <windows.h>



mxcpcTime::mxcpcTime() {

  setBaseTime();
}



void mxcpcTime::setBaseTime(void) {

  BaseTicks = GetTickCount();
}


int mxcpcTime::elapsed(void) {

  unsigned long current_ticks;
  int delta_msecs;
  
  current_ticks = GetTickCount();
  
  if(current_ticks > BaseTicks) {
    delta_msecs = (int)(current_ticks - BaseTicks);
  }
  else {
    mxcpc::sendStatusMsg("Time_win : *** tick counter overflow detected!");
    delta_msecs = 0;
  }
  if(delta_msecs < 0) {
    mxcpc::sendStatusMsg("Time_win : *** time difference too high!");
    delta_msecs = 0;
  }
    
  BaseTicks = current_ticks;
  
  return(delta_msecs);
}

