//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpc_namespace.cpp,v $
//       ///       XXX       ///     $Revision: 1.7 $
//      ///      XXX XXX      ///     $Date: 2006/01/20 11:57:00 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpc_namespace.h>
#include <mxcpcStatusMessageHandler.h>

#include <cstdio>



const char *mxcpc::Base64EncodeTable = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                                       "abcdefghijklmnopqrstuvwxyz"
                                       "0123456789"
                                       "+/";

int mxcpc::FrameRatePresetNum = 12;
char *mxcpc::FrameRatePresetNames[] = { "Maximum",
                                        "25 fps",
                                        "12 fps",
                                        " 6 fps",
                                        " 4 fps",
                                        " 3 fps",
                                        " 2 fps",
                                        " 1 fps",
                                        "1/2 fps", 
                                        "1/3 fps",
                                        "1/4 fps",
                                        "1/5 fps"      
                                      };
float mxcpc::FrameRatePresets[] = {  0.0f,
                                    25.0f,
                                    12.0f,
                                     6.0f,
                                     4.0f,
                                     3.0f,
                                     2.0f,
                                     1.0f,
                                      .5f,
                                      .33f,
                                      .25f,
                                      .2f
                                  };
                                       
mxcpcStatusMessageHandler *mxcpc::StatusMessageHandler = 0;


      
const char *mxcpc::getVersionString(void){

  return("MxPEG SDK / mxcpc v0.9.1   (c) 2005-2006 MOBOTIX AG"); 
}


void mxcpc::sendStatusMsg(const char *txt, void *class_ptr) {

  if(StatusMessageHandler)
   StatusMessageHandler->sendStatusMsg(txt, class_ptr); 
  else 
   std::printf("mxcpc : %s\n", txt);
}


void mxcpc::setStatusMessageHandler(mxcpcStatusMessageHandler *handler) {

  delete StatusMessageHandler;
  
  StatusMessageHandler = handler;
}


void mxcpc::encode_base64_block(unsigned char in[3], 
                                unsigned char out[4], 
                                int len)              {
  
  out[0] = Base64EncodeTable[in[0] >> 2];
  out[1] = Base64EncodeTable[((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4)];
  out[2] 
   = (unsigned char)(
       len > 1 
       ? Base64EncodeTable[((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6)] 
       : '='
     );
  out[3] = (unsigned char) (len > 2 ? Base64EncodeTable[in[2] & 0x3f] : '=');
}


/*!
 *  The generated base64 string will be <tt>0</tt>-terminated.
 *
 *  Note that the target buffer must be of reasonable size, namely of at least
 *   <tt>(byte_num/3 + 1) * 4 + 1</tt> bytes.
 *
 *  \note The base64 encoding code was adapted from some Bob Trower who has 
 *  released it to the public domain.
 */
void mxcpc::encode_base64(unsigned char *data, int byte_num, 
                          unsigned char *target_buffer)      {
  
  unsigned char in[3], out[4];
  int i, len;
  
  while(byte_num) {
    
    // get next 3-byte block of binary input data...
    len = 0;
    for(i = 0; i < 3; i++ ) {
      if(byte_num) {
        in[i] = (unsigned char) *data++;
        byte_num--;
        len++;
      }
      else {
        in[i] = 0;
      }
    }
    
    // generate corresponding 4-byte base64 block...
    encode_base64_block(in, out, len);
    
    // ... and write it to target buffer...
    *target_buffer++ = out[0];
    *target_buffer++ = out[1];
    *target_buffer++ = out[2];
    *target_buffer++ = out[3];
  }  
  
  // properly terminate base64-string in target buffer
  *target_buffer = 0;
}

