//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcAuthenticationDialog.h,v $
//       ///       XXX       ///     $Revision: 1.4 $
//      ///      XXX XXX      ///     $Date: 2006/01/05 11:56:09 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_AUTHENTICATIONDIALOG_H__
#define __MXCPC_AUTHENTICATIONDIALOG_H__



#include <mxcpcDialog.h>



class QLabel;
class QLineEdit;



//! Dialog querying for user name and password.
/*!
 *  \ingroup mxcpc_gui
 */
class mxcpcAuthenticationDialog : public mxcpcDialog {

  Q_OBJECT
  
 private:
  QLabel *MessageLabel; 
  QLineEdit *UserEdit, *PasswordEdit;
  
 public:
  mxcpcAuthenticationDialog(QWidget *parent = 0);

 signals:
  //! Emmitted when the user commits the authentication data.
  void authenticationCommitted(QString user, QString password);
  //! Emmitted when the user has cancelled authentication.
  void authenticationCancelled(void);
  
 public slots:
  //! Sets the text message displayed above the login and password input fields.
  void setMessage(const QString& msg);
  //! Shows and raises the authentication dialog.
  void openDialog(const QString& msg);
  
 protected:
  void closeEvent(QCloseEvent *e); 
  
 private slots:
  void okClicked(void);
  void cancelClicked(void);
};



#endif   // __MXCPC_AUTHENTICATIONDIALOG_H__

