//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcCameraSelector.h,v $
//       ///       XXX       ///     $Revision: 1.5 $
//      ///      XXX XXX      ///     $Date: 2006/01/04 16:38:20 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_CAMERA_SELECTOR_H__
#define __MXCPC_CAMERA_SELECTOR_H__



#include <mxcpcIPAddress.h>
#include <mxcpcProxyConfiguration.h>

#include <QWidget>



class mxcpcIPEdit;

class QSpinBox;
class QCheckBox;



//! Widget allowing the user to choose a <tt>MOBOTIX</tt> camera.
/*!
 *  \ingroup mxcpc_gui
 */
class mxcpcCameraSelector : public QWidget {
 
  Q_OBJECT
  
 private:
  mxcpcIPEdit *CameraIPEdit,*ProxyIPEdit;
  QSpinBox *CameraPortSpinBox, *ProxyPortSpinBox;
  QCheckBox *ProxyCheckBox;
  
 public:
  mxcpcCameraSelector(QWidget *parent);
  
 public:
  //! Returns the currently set camera IP.
  mxcpcIPAddress cameraIP(void);
  //! Returns the currently set camera (HTTP) port.
  int cameraPort(void);
  //! Returns the proxy configuration for the currently set camera.
  mxcpcProxyConfiguration cameraProxyConfiguration(void);
  
 private slots:
  void processProxyCheckBoxStateChanged(int state);
};



#endif   // __MX_CAMERA_SELECTOR_H__
