//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFastStreamSelectionDialog.h,v $
//       ///       XXX       ///     $Revision: 1.3 $
//      ///      XXX XXX      ///     $Date: 2006/01/05 11:56:09 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_FASTSTREAMSELECTIONDIALOG_H__
#define __MXCPC_FASTSTREAMSELECTIONDIALOG_H__



#include <mxcpcDialog.h>



class mxcpcIPAddress;
class mxcpcProxyConfiguration;
class mxcpcCameraSelector;
class mxcpcFastStreamParametersSelector;



//! Dialog letting the user choose a camera faststream connection.
/*!
 *  \ingroup mxcpc_gui
 */
class mxcpcFastStreamSelectionDialog : public mxcpcDialog {
  
  Q_OBJECT
 
 private: 
  mxcpcCameraSelector *CameraSelector;
  mxcpcFastStreamParametersSelector *FastStreamParametersSelector;
 
 public:
  mxcpcFastStreamSelectionDialog(QWidget *parent);

 signals:
  //! Emitted when the user has made his selection.
  void fastStreamSelected(
         const mxcpcIPAddress &camera_ip,
         int camera_port,
         const mxcpcProxyConfiguration& camera_proxy_configuration,
         float fps
       );

 private slots:
  void processOkClicked(void);
  void processCancelClicked(void);
};



#endif   // __MXCPC_FASTSTREAMSELECTIONDIALOG_H__

