//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcAuthenticationDialog.cpp,v $
//       ///       XXX       ///     $Revision: 1.4 $
//      ///      XXX XXX      ///     $Date: 2006/01/05 11:56:09 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcAuthenticationDialog.h>
#include <mxcpc_gui_config.h>

#include <QHBoxLayout>
#include <QGridLayout>
#include <QLabel>
#include <QLineEdit>
#include <QPushButton>



mxcpcAuthenticationDialog::mxcpcAuthenticationDialog(QWidget *parent)
                            : mxcpcDialog(parent)                     {

  QHBoxLayout *h_layout;
  QGridLayout *grid_layout;
  QLabel      *label;               
  QWidget     *widget, *widget2;
  QLineEdit   *line_edit;
  QPushButton *button;
  
  setWindowTitle(QString("Authentication Dialog"));

  h_layout = new QHBoxLayout(this);
  h_layout->setSizeConstraint(QLayout::SetFixedSize);
  h_layout->setSpacing(MXCPC_DIALOG_SPACING);
  
  label = new QLabel(QString("KEY"), this);
  h_layout->addWidget(label, 0, Qt::AlignTop);
  label->setPixmap(QPixmap(":images/dialog_authenticate.png"));
  widget = new QWidget(this);
  h_layout->addWidget(widget);
  
  grid_layout = new QGridLayout(widget);
  grid_layout->setSpacing(MXCPC_DIALOG_SPACING);
  grid_layout->setMargin(0);
  
  MessageLabel = label = new QLabel(QString("Message"), widget);
  grid_layout->addWidget(label, 0, 0, 1, 2);
  label->setWordWrap(true);
  label = new QLabel(QString("User :"), widget);
  grid_layout->addWidget(label, 1, 0);
  label = new QLabel(QString("Password :"), widget);
  grid_layout->addWidget(label, 2, 0);
  UserEdit = line_edit = new QLineEdit(widget);
  grid_layout->addWidget(line_edit, 1, 1);
  PasswordEdit = line_edit = new QLineEdit(widget);
  grid_layout->addWidget(line_edit, 2, 1);
  line_edit->setEchoMode(QLineEdit::Password);
  
  widget2 = new QWidget(widget);                              
  grid_layout->addWidget(widget2, 3, 0, 1, 2);
  
  h_layout = new QHBoxLayout(widget2);
  h_layout->setSpacing(MXCPC_DIALOG_SPACING);
  h_layout->setMargin(0);
  
  button = new QPushButton(QString("Cancel"), widget2);
  h_layout->addWidget(button);
  button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                    QSizePolicy::Fixed));
  QObject::connect(button, SIGNAL(clicked(void)),
                   this, SLOT(cancelClicked(void)));
  button = new QPushButton(QString("OK"), widget2);
  h_layout->addWidget(button);
  button->setDefault(true);
  button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                    QSizePolicy::Fixed));
  QObject::connect(button, SIGNAL(clicked(void)),
                   this, SLOT(okClicked(void)));
}


void mxcpcAuthenticationDialog::setMessage(const QString& msg) {

  MessageLabel->setText(msg);  
}


void mxcpcAuthenticationDialog::openDialog(const QString& msg) {

  setMessage(msg);

  mxcpcDialog::openDialog();  
}


void mxcpcAuthenticationDialog::closeEvent(QCloseEvent *e) {

  emit authenticationCancelled();
}


void mxcpcAuthenticationDialog::okClicked(void) {

  hide();
  
  emit authenticationCommitted(UserEdit->text(), PasswordEdit->text());
}


void mxcpcAuthenticationDialog::cancelClicked(void) {

  hide();
  
  emit authenticationCancelled();
}
