//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcCameraSelector.cpp,v $
//       ///       XXX       ///     $Revision: 1.6 $
//      ///      XXX XXX      ///     $Date: 2006/01/05 12:19:20 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcCameraSelector.h>
#include <mxcpcIPEdit.h>

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLabel>
#include <QSpinBox>
#include <QComboBox>
#include <QCheckBox>
#include <QFrame>



mxcpcCameraSelector::mxcpcCameraSelector(QWidget *parent) 
                      : QWidget(parent)                   {
                        
  mxcpcIPEdit *ip_edit;
  QVBoxLayout *layout;
  QHBoxLayout *layout2;
  QLabel *label;
  QSpinBox *spin_box;
  QComboBox *combo_box;
  QCheckBox *checkbox;
  QFrame *frame;
  
  layout = new QVBoxLayout(this);
  layout->setMargin(0);
  //layout->setSizeConstraint(QLayout::SetFixedSize);
  
  combo_box = new QComboBox(this);
  layout->addWidget(combo_box, 0, Qt::AlignHCenter);
  combo_box->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                       QSizePolicy::Fixed));
  //combo_box->addItem(QString("MOBOTIX Units On Local Subnet"));                                     
  //combo_box->addItem(QString("Recently Connected"));
  combo_box->addItem(QString("Specify Manually"));
  
  frame = new QFrame(this);
  layout->addWidget(frame);
  frame->setFrameStyle(QFrame::HLine | QFrame::Sunken);
  
  CameraIPEdit = ip_edit = new mxcpcIPEdit(this);
  layout->addWidget(ip_edit);
  
  layout2 = new QHBoxLayout();
  layout->addLayout(layout2);

  label = new QLabel(QString("Camera Port:"), this);
  layout2->addWidget(label);
  CameraPortSpinBox = spin_box = new QSpinBox(this);
  layout2->addWidget(spin_box);
  spin_box->setMinimum(0);
  spin_box->setMaximum(65536);
  spin_box->setValue(80);
  spin_box->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                      QSizePolicy::Fixed));  
                       
  frame = new QFrame(this);
  layout->addWidget(frame);
  frame->setFrameStyle(QFrame::HLine | QFrame::Sunken);
                                      
  ProxyCheckBox
   = checkbox 
   = new QCheckBox(QString("Access this Camera through Proxy Server"), 
                   this);
  layout->addWidget(checkbox);
  checkbox->setChecked(false);
  QObject::connect(checkbox, SIGNAL(stateChanged(int)),
                   this, SLOT(processProxyCheckBoxStateChanged(int)));
  
  ProxyIPEdit = ip_edit = new mxcpcIPEdit(this);
  layout->addWidget(ip_edit);
  ip_edit->setIPAddress(mxcpcIPAddress(192, 168, 1, 254));
  ip_edit->setEnabled(false);
  
  layout2 = new QHBoxLayout();
  layout->addLayout(layout2);

  label = new QLabel(QString("Proxy Port:"), this);
  layout2->addWidget(label);
  ProxyPortSpinBox = spin_box = new QSpinBox(this);
  layout2->addWidget(spin_box);
  spin_box->setMinimum(0);
  spin_box->setMaximum(65536);
  spin_box->setValue(8080);
  spin_box->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                      QSizePolicy::Fixed));
  spin_box->setEnabled(false);
}



mxcpcIPAddress mxcpcCameraSelector::cameraIP(void) {

  return(CameraIPEdit->getIPAddress());
}


int mxcpcCameraSelector::cameraPort(void) {
  
  return(CameraPortSpinBox->value());
}


mxcpcProxyConfiguration mxcpcCameraSelector::cameraProxyConfiguration(void) {

  if(ProxyCheckBox->checkState() == Qt::Checked) {
    return(mxcpcProxyConfiguration(ProxyIPEdit->getIPAddress(),
                                   ProxyPortSpinBox->value()));
  }
  else {
    return(mxcpcProxyConfiguration());   // don't use any proxy
  }
}


void mxcpcCameraSelector::processProxyCheckBoxStateChanged(int state) {

  ProxyIPEdit->blockSignals(true);
  ProxyPortSpinBox->blockSignals(true);
  
  if(state == Qt::Checked) {
    ProxyIPEdit->setEnabled(true);
    ProxyPortSpinBox->setEnabled(true);
  }
  else {
    ProxyIPEdit->setEnabled(false);
    ProxyPortSpinBox->setEnabled(false);
  }
  
  ProxyIPEdit->blockSignals(false);
  ProxyPortSpinBox->blockSignals(false);
}

