//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFastStreamSelectionDialog.cpp,v $
//       ///       XXX       ///     $Revision: 1.3 $
//      ///      XXX XXX      ///     $Date: 2006/01/05 11:56:09 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcFastStreamSelectionDialog.h>
#include <mxcpcCameraSelector.h>
#include <mxcpcFastStreamParametersSelector.h>
#include <mxcpc_gui_config.h>

#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QGroupBox>
#include <QPushButton>
#include <QLabel>



mxcpcFastStreamSelectionDialog::mxcpcFastStreamSelectionDialog(QWidget *parent)
                                 : mxcpcDialog(parent)                         {
  
  QVBoxLayout *layout, *layout2;
  QHBoxLayout *layout3,*layout4;
  QGroupBox *group_box;
  QPushButton *button;
  QLabel *label;
  QWidget *widget;
  mxcpcCameraSelector *camera_selector;
  mxcpcFastStreamParametersSelector *stream_parameters_selector;
  
  setWindowTitle(QString("FastStream Selection Dialog"));
  
  layout4 = new QHBoxLayout(this);
  layout4->setSizeConstraint(QLayout::SetFixedSize);
  
  label = new QLabel(this);
  layout4->addWidget(label, 0, Qt::AlignTop);
  label->setPixmap(QPixmap(":images/dialog_faststream.png"));
  
  layout = new QVBoxLayout();
  layout4->addLayout(layout),
  layout->setSpacing(MXCPC_DIALOG_SPACING);
  
  group_box = new QGroupBox(QString("Camera"), this);
  layout->addWidget(group_box);
  layout2 = new QVBoxLayout(group_box);
  CameraSelector = camera_selector = new mxcpcCameraSelector(group_box);
  layout2->addWidget(camera_selector);

  group_box = new QGroupBox(QString("Stream Parameters"), this);
  layout->addWidget(group_box);
  layout2 = new QVBoxLayout(group_box);
  FastStreamParametersSelector 
   = stream_parameters_selector
   = new mxcpcFastStreamParametersSelector(group_box);
  layout2->addWidget(stream_parameters_selector);

  layout3 = new QHBoxLayout();
  layout->addLayout(layout3);
  button = new QPushButton(QString("Cancel"), this);
  layout3->addWidget(button);
  button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                    QSizePolicy::Fixed));
  QObject::connect(button, SIGNAL(clicked(void)),
                   this, SLOT(processCancelClicked(void)));
  widget = new QWidget(this);
  layout3->addWidget(widget);
  button = new QPushButton(QString("OK"), this);
  layout3->addWidget(button);
  button->setDefault(true);
  button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                    QSizePolicy::Fixed));
  QObject::connect(button, SIGNAL(clicked(void)),
                   this, SLOT(processOkClicked(void)));
}



void mxcpcFastStreamSelectionDialog::processCancelClicked(void) {

  hide();
}


void mxcpcFastStreamSelectionDialog::processOkClicked(void) {

  hide();
    
  emit fastStreamSelected(CameraSelector->cameraIP(),
                          CameraSelector->cameraPort(),
                          CameraSelector->cameraProxyConfiguration(),
                          FastStreamParametersSelector->getFrameRate());
}

