//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcIPEdit.cpp,v $
//       ///       XXX       ///     $Revision: 1.3 $
//      ///      XXX XXX      ///     $Date: 2006/01/05 12:19:20 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcIPEdit.h>
#include <mxcpc_gui_config.h>

#include <QLayout>
#include <QSpinBox>
#include <QLabel>



mxcpcIPEdit::mxcpcIPEdit(QWidget *parent) : QWidget(parent) {

  QHBoxLayout *layout;
  QSpinBox *spin_box;
  QLabel *label;
  int i;
  
  layout = new QHBoxLayout(this);
  layout->setMargin(0);
  //layout->setSizeConstraint(QLayout::SetFixedSize);
  
  for(i = 0; i < 4; i++) {
  
    IPEdit[i] = spin_box = new QSpinBox(this);
    layout->addWidget(spin_box);
    spin_box->setMinimum(0);
    spin_box->setMaximum(255);
                                        
    if(i < 3) {
      
      label = new QLabel(QString("."), this);
      layout->addWidget(label);
      label->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                       QSizePolicy::Fixed));
    }
  }
  
  setIPAddress(mxcpcIPAddress(10, 0, 0, 1));
}



void mxcpcIPEdit::setIPAddress(const mxcpcIPAddress& ip) {
 
  int i;
  
  for(i = 0; i < 4; i++) IPEdit[i]->blockSignals(true);
  IPEdit[0]->setValue(ip.getIP1());
  IPEdit[1]->setValue(ip.getIP2());
  IPEdit[2]->setValue(ip.getIP3());
  IPEdit[3]->setValue(ip.getIP4());
  for(i = 0; i < 4; i++) IPEdit[i]->blockSignals(false);
}


mxcpcIPAddress mxcpcIPEdit::getIPAddress(void) {

  return(mxcpcIPAddress(IPEdit[0]->value(),
                        IPEdit[1]->value(),
                        IPEdit[2]->value(),
                        IPEdit[3]->value()));
}
