//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcMessageDialog.cpp,v $
//       ///       XXX       ///     $Revision: 1.5 $
//      ///      XXX XXX      ///     $Date: 2006/01/05 11:56:09 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcMessageDialog.h>
#include <mxcpc_gui_config.h>

#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QPixmap>
#include <QLabel>
#include <QPushButton>



mxcpcMessageDialog::mxcpcMessageDialog(QWidget *parent)
                     : mxcpcDialog(parent)              {
                                         
  QHBoxLayout *h_layout;
  QVBoxLayout *v_layout;
  QLabel *label;
  QPushButton *button;
  QWidget *widget;
  
  setWindowTitle(QString("Mx Message"));

  h_layout = new QHBoxLayout(this);
  h_layout->setSizeConstraint(QLayout::SetFixedSize);
  h_layout->setSpacing(MXCPC_DIALOG_SPACING);

  label = new QLabel(this);
  h_layout->addWidget(label, 0, Qt::AlignTop);
  label->setPixmap(QPixmap(":images/dialog_message.png"));
  
  widget = new QWidget(this);
  h_layout->addWidget(widget);
  
  v_layout = new QVBoxLayout(widget);
  v_layout->setSpacing(MXCPC_DIALOG_SPACING);
  
  MessageTextLabel = label = new QLabel(QString("<Message>"), widget);
  v_layout->addWidget(label, 0, Qt::AlignHCenter);
  
  button = new QPushButton(QString("Close"), widget);
  v_layout->addWidget(button, 0, Qt::AlignHCenter);
  button->setDefault(true);
  button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                    QSizePolicy::Preferred));
  QObject::connect(button, SIGNAL(clicked(void)),
                   this, SLOT(hide(void)));
}


void mxcpcMessageDialog::setMessage(const QString& title,
                                    const QString& message) {

  setWindowTitle(title);
  MessageTextLabel->setText(message);
}

