//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcSDKInfoDialog.cpp,v $
//       ///       XXX       ///     $Revision: 1.4 $
//      ///      XXX XXX      ///     $Date: 2006/01/17 16:20:34 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#include <mxcpcSDKInfoDialog.h>
#include <mxcpc_namespace.h>
#include <mxcpc_gui_config.h>

#include <QVBoxLayout>
#include <QLabel>
#include <QPushButton>
#include <QTimer>
#include <QFrame>



mxcpcSDKInfoDialog::mxcpcSDKInfoDialog(QWidget *parent)
                     : mxcpcDialog(parent)              {
                       
  QVBoxLayout *layout;
  QLabel *label;
  QPushButton *button;
  QFrame *frame;
  
  setWindowTitle(QString("Information"));
  
  layout = new QVBoxLayout(this);
  layout->setSizeConstraint(QLayout::SetFixedSize);
  layout->setMargin(0);
  layout->setSpacing(0);
  
  label = new QLabel(this);
  layout->addWidget(label);
  label->setPixmap(QPixmap(":images/sdk_logo.png"));
  
  label = new QLabel(QString("Version"));
  layout->addWidget(label);
  label->setAlignment(Qt::AlignHCenter);
  label->setText(QString(mxcpc::getVersionString()));
  
  frame = new QFrame(this);
  layout->addWidget(frame);
  frame->setFrameStyle(QFrame::HLine | QFrame::Sunken);
  
  layout->addSpacing(MXCPC_DIALOG_SPACING);
  
  button = new QPushButton(QString("Close"), this);
  layout->addWidget(button, 0, Qt::AlignHCenter);
  button->setDefault(true);
  button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed,
                                    QSizePolicy::Fixed));
  QObject::connect(button, SIGNAL(clicked(void)),
                   this, SLOT(processCloseClicked(void)));

  AutoCloseTimer = new QTimer(this);                     
  QObject::connect(AutoCloseTimer, SIGNAL(timeout(void)),
                   this, SLOT(hide(void)));
                  
  layout->addSpacing(MXCPC_DIALOG_SPACING);
}



void mxcpcSDKInfoDialog::hideLater(int msecs) {

  if(msecs < 1) msecs = 4000;
  
  AutoCloseTimer->setSingleShot(true);
  AutoCloseTimer->start(msecs);
}


void mxcpcSDKInfoDialog::processCloseClicked(void) {

  hide();
}
