//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcBufferedMxPEGVideoRenderer.h,v $
//       ///       XXX       ///     $Revision: 1.5 $
//      ///      XXX XXX      ///     $Date: 2006/01/18 17:24:59 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_BUFFEREDMXPEGVIDEORENDERER_H__
#define __MXCPC_BUFFEREDMXPEGVIDEORENDERER_H__



#include <mxcpcBufferedMxPEGDecoderBackEnd.h>

#include <QObject>
#include <QTime>



class mxcpcVideoDisplay;



//! <tt>OpenGL</tt>-based <tt>MxPEG</tt> decoder backend internally buffering
//! video tile updates and transmitting to the graphics hardware frame-wise and
//! only as frames complete. 
/*!
 *  \ingroup mxcpc_tek
 *
 *  This backend was devised to be used with the mxcpcSimpleMxPEGViewer.
 *
 *  It uses the classic Mx approach - opposed to the alternative of writing to
 *  the graphics hardware tile-wise and upon arrival of every single tile as it
 *  is done by mxcpcSimpleMxPEGVideoTileRenderer.
 */
class mxcpcBufferedMxPEGVideoRenderer 
       : public QObject,
         public mxcpcBufferedMxPEGDecoderBackEnd
                                                 {

  Q_OBJECT
  
 private:
  mxcpcVideoDisplay *Viewer;
  int CenterX, CenterY,
      OffsetX, OffsetY;
  int FrameCount;
  int FramerateMeasureInterval;
  QTime FramerateMeasureTime;
  int FramerateFrameCount;
  
 public:
  //! The constructor does <b>not</b> assume ownership over the viewer widget!
  mxcpcBufferedMxPEGVideoRenderer(mxcpcVideoDisplay *viewer);
  ~mxcpcBufferedMxPEGVideoRenderer();
  
 signals:
  //! Emitted if framerate measure mode is enabled and a new framerate measure
  //! becomes available (roughly every <i>n</i> milliseconds with <i>n</i> 
  //! as it was specified to setFramerateMeasureModeEnabled()).
  void framerateMeasured(float fps);

 public:
  //! Retrieves the current value of the renderer's internal frame counter.
  int getFrameCount(void);
  //! Toggles framerate measure mode.
  void setFramerateMeasureModeEnabled(bool enabled, 
                                      int measure_interval_ms = 10000);
  
  //! (Re)implemented.
  void videoResolutionChanged(int width, int height);
  //! (Re)implemented.
  void errorEncountered(void);
  //! (Re)implemented.
  void frameComplete(void);
  //! (Re)implemented.
  void videoTileReceived(void);
};




#endif   // __MXCPC_BUFFEREDMXPEGVIDEORENDERER_H__
