//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFramewiseMxPEGScanDecoderIPP.h,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/12/20 16:41:56 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////



#ifndef __MXCPC_FRAMEWISEMXPEGSCANDECODERIPP_H__
#define __MXCPC_FRAMEWISEMXPEGSCANDECODERIPP_H__



#include <mxcpcFramewiseMxPEGScanDecoder.h>

#include <ippj.h>



//! Framewise <tt>MxPEG</tt> scan decoder implementation using Intel's
//! <i>Performance Primitives</i> library.
/*!
 *  \ingroup mxcpc
 */
class mxcpcFramewiseMxPEGScanDecoderIPP : public mxcpcFramewiseMxPEGScanDecoder {

 private:
  IppiDecodeHuffmanSpec *HuffmanTree_Y_DC,
                        *HuffmanTree_Y_AC,
                        *HuffmanTree_UV_DC,
                        *HuffmanTree_UV_AC;
  Ipp16u QuantizationTable_Y[64],
         QuantizationTable_UV[64];
  Ipp16s DecodedHuffmanCoeffs[6][64];   
  Ipp8u  Y_ColorValues[16*16],
         U_ColorValues[8*8],
         V_ColorValues[8*8];
                        
 public:
  mxcpcFramewiseMxPEGScanDecoderIPP();
  ~mxcpcFramewiseMxPEGScanDecoderIPP();
  
 public:
  //! (Re)implemented.
  const char *getAccelerationTypeString(void);
  //! (Re)implemented.
  void setYQuantizationTable(unsigned char *data_bytes);
  //! (Re)implemented.
  void setUVQuantizationTable(unsigned char *data_bytes);
  //! (Re)implemented.
  void performScanSweep(mxcpcFramewiseMxPEGDecoder::UndecodedFrameDescriptor
                         *frame_descriptor); 
};



#endif   // __MXCPC_FRAMEWISEMXPEGSCANDECODERIPP_H__
