//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFramewiseMxPEGScanToJPEGConverterIPP.h,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/12/20 16:41:56 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////



#ifndef __MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTERIPP_H__
#define __MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTERIPP_H__



#define MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTERIPP_BITSTREAM_BUFFSIZE 512



#include <mxcpcFramewiseMxPEGScanToJPEGConverter.h>
#include <mxcpc_mxpeg_namespace.h>

#include <ippj.h>



class mxcpcJPEGReceiver;



//! Experimental framewise scan decoder implementation converting an 
//! <tt>MxPEG</tt> stream to a sequence of JPEG images. 
/*!
 *  \ingroup mxcpc
 *
 *  Does not use the decoder backend.
 */
class mxcpcFramewiseMxPEGScanToJPEGConverterIPP 
       : public mxcpcFramewiseMxPEGScanToJPEGConverter {

 private:
  static const unsigned char ZigZag_StoreMap[64];

 private:
  IppiDecodeHuffmanSpec *HuffmanTree_Y_DC,
                        *HuffmanTree_Y_AC,
                        *HuffmanTree_UV_DC,
                        *HuffmanTree_UV_AC;
  Ipp16u QuantizationTable_Y[64],
         QuantizationTable_UV[64];
  Ipp16s *CoeffBuffer;
  int TileNumX, TileNumY;
  IppiEncodeHuffmanSpec *HuffmanEncodeSpec_Y_DC,
                        *HuffmanEncodeSpec_Y_AC,
                        *HuffmanEncodeSpec_UV_DC,
                        *HuffmanEncodeSpec_UV_AC;
  mxcpc_mxpeg::APP0 APP0_Block;
  mxcpc_mxpeg::SOF0 SOF0_Block;
  mxcpc_mxpeg::SOS  SOS_Block;         
  int FramesProcessed;
  
 public:
  //! The converter assumes ownership over the converter backend.
  mxcpcFramewiseMxPEGScanToJPEGConverterIPP(
   mxcpcJPEGReceiver *receiver
  );
  ~mxcpcFramewiseMxPEGScanToJPEGConverterIPP();
  
 public:
  //! (Re)implemented.
  const char *getAccelerationTypeString(void);
  //! (Re)implemented.
  void setYQuantizationTable(unsigned char *data_bytes);
  //! (Re)implemented.
  void setUVQuantizationTable(unsigned char *data_bytes);
  //! (Re)implemented.
  void performScanSweep(mxcpcFramewiseMxPEGDecoder::UndecodedFrameDescriptor
                         *frame_descriptor); 
};



#endif   // __MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTERIPP_H__
