//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcMxPEGCodecFactory.h,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/12/20 16:41:56 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_MXPEGCODECFACTORY_H__
#define __MXCPC_MXPEGCODECFACTORY_H__



class mxcpcFramewiseMxPEGScanDecoder;
class mxcpcFramewiseMxPEGScanToJPEGConverter;
class mxcpcJPEGReceiver;



//! Interface to all <tt>MxPEG</tt> codec factories
/*!
 *  \ingroup mxcpc_tek
 */
class mxcpcMxPEGCodecFactory {

 public:
  virtual ~mxcpcMxPEGCodecFactory();
        
 public:
  //! Creates a framewise <tt>MxPEG</tt> scan decoder.
  virtual mxcpcFramewiseMxPEGScanDecoder 
           *newFramewiseMxPEGScanDecoder(void)
   = 0;
  //! Creates a framewise <tt>MxPEG</tt> scan to JPEG converter.                                        
  virtual mxcpcFramewiseMxPEGScanToJPEGConverter 
           *newFramewiseMxPEGScanToJPEGConverter(mxcpcJPEGReceiver *receiver)
   = 0;
};



#endif   // __MXCPC_MXPEGCODECFACTORY_H__

