//           ///          //                                        Mx clientSDK
//          /////        ////                    Mx Crossplatform Client Library
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcProxyConfiguration.h,v $
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2006/01/04 16:38:20 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems //////////////////////////////////////////////
//                                                                          //
//  Copyright (C) 2005 - 2006, MOBOTIX AG, Germany                         //
//  This software is made available under the BSD licence. Please refer   //
//  to the file LICENCE.TXT contained in this distribution for details.  //
//                                                                      //
//  /////////////////////////////////////////////////////////////////////



#ifndef __MXCPC_PROXYCONFIGURATION_H__
#define __MXCPC_PROXYCONFIGURATION_H__



#include <mxcpcIPAddress.h>



//! Holds a proxy configuration.
/*!
 *  \ingroup mxcpc_tek
 */
class mxcpcProxyConfiguration {
 
 private:
  mxcpcIPAddress ServerIP;
  int            ServerPort;
  bool           UseProxy;

 public:
  //! Creates "use proxy" configuration with proxy server as specified.
  mxcpcProxyConfiguration(const mxcpcIPAddress& server_ip,
                          int server_port);
  //! Creates default "no proxy" configuration.
  mxcpcProxyConfiguration();
  
 public:
  //! Sets the proxy server IP address.
  void setServerIP(const mxcpcIPAddress& ip);
  //! Retrieves the proxy server IP address.
  mxcpcIPAddress serverIP(void);
  //! Sets the proxy server port.
  void setServerPort(int port);
  //! Retrieves the proxy server port.
  int serverPort(void);
  //! Toggles whether or not the proxy server is used.
  void setProxyUsed(bool proxy_used);
  //! Tells whether or not the proxy server is used.
  bool proxyUsed(void);
};



#endif   // __MXCPC_PROXYCONFIGURATION_H__

