//           ///          //
//          /////        ////
//         /// XXX     XXX ///
//        ///    XXX XXX    ///     $RCSfile: mxcpcFramewiseMxPEGScanToJPEGConverterIPP.cpp,v $  
//       ///       XXX       ///     $Revision: 1.1 $
//      ///      XXX XXX      ///     $Date: 2005/12/20 16:41:56 $
//     ////    XXX     XXX    ////     $Author: cvs-kai $
//    ////                     ////
//   ////  M  O  B  O  T  I  X  ////////////////////////////////////////////////
//  //// Security Vision Systems ///////////////////////////////////////////////



#include <mxcpcFramewiseMxPEGScanToJPEGConverterIPP.h>
#include <mxcpcMxPEGDecoderBackEnd.h>
#include <mxcpcJPEGReceiver.h> 
#include <mxcpc_exceptions.h>

#include <memory>



const unsigned char mxcpcFramewiseMxPEGScanToJPEGConverterIPP
                     ::ZigZag_StoreMap[64] = {
  0,  1,  5,  6, 14, 15, 27, 28,
  2,  4,  7, 13, 16, 26, 29, 42,
  3,  8, 12, 17, 25, 30, 41, 43,
  9, 11, 18, 24, 31, 40, 44, 53,
  10, 19, 23, 32, 39, 45, 52, 54,
  20, 22, 33, 38, 46, 51, 55, 60,
  21, 34, 37, 47, 50, 56, 59, 61,
  35, 36, 48, 49, 57, 58, 62, 63
};



mxcpcFramewiseMxPEGScanToJPEGConverterIPP
 ::mxcpcFramewiseMxPEGScanToJPEGConverterIPP(mxcpcJPEGReceiver *receiver)
    : mxcpcFramewiseMxPEGScanToJPEGConverter(receiver)                    {

  int huffman_size;
  int i;
  
  HuffmanTree_Y_DC  = 0;
  HuffmanTree_Y_AC  = 0;
  HuffmanTree_UV_DC = 0;
  HuffmanTree_UV_AC = 0;
  HuffmanEncodeSpec_Y_DC  = 0;
  HuffmanEncodeSpec_Y_AC  = 0;
  HuffmanEncodeSpec_UV_DC = 0;
  HuffmanEncodeSpec_UV_AC = 0;
    
  ippiDecodeHuffmanSpecGetBufSize_JPEG_8u(&huffman_size);
  HuffmanTree_Y_DC  = (IppiDecodeHuffmanSpec *)std::malloc(huffman_size);
  HuffmanTree_Y_AC  = (IppiDecodeHuffmanSpec *)std::malloc(huffman_size);
  HuffmanTree_UV_DC = (IppiDecodeHuffmanSpec *)std::malloc(huffman_size);
  HuffmanTree_UV_AC = (IppiDecodeHuffmanSpec *)std::malloc(huffman_size);
  ippiEncodeHuffmanSpecGetBufSize_JPEG_8u(&huffman_size);
  HuffmanEncodeSpec_Y_DC  = (IppiEncodeHuffmanSpec *)std::malloc(huffman_size);
  HuffmanEncodeSpec_Y_AC  = (IppiEncodeHuffmanSpec *)std::malloc(huffman_size);
  HuffmanEncodeSpec_UV_DC = (IppiEncodeHuffmanSpec *)std::malloc(huffman_size);
  HuffmanEncodeSpec_UV_AC = (IppiEncodeHuffmanSpec *)std::malloc(huffman_size);
  
  if(   !HuffmanTree_Y_DC
     || !HuffmanTree_Y_AC
     || !HuffmanTree_UV_DC
     || !HuffmanTree_UV_AC
     || !HuffmanEncodeSpec_Y_DC
     || !HuffmanEncodeSpec_Y_AC
     || !HuffmanEncodeSpec_UV_DC
     || !HuffmanEncodeSpec_UV_AC) {
    
    std::free(HuffmanTree_Y_DC);
    std::free(HuffmanTree_Y_AC);
    std::free(HuffmanTree_UV_DC);
    std::free(HuffmanTree_UV_AC);
    std::free(HuffmanEncodeSpec_Y_DC);
    std::free(HuffmanEncodeSpec_Y_AC);
    std::free(HuffmanEncodeSpec_UV_DC);
    std::free(HuffmanEncodeSpec_UV_AC);
    
    throw std::bad_alloc();
  }
  
  try {
     
    if(ippiDecodeHuffmanSpecInit_JPEG_8u(&DefaultHuffmanTable_Y_DC[0],
                                         &DefaultHuffmanTable_Y_DC[16],
                                         HuffmanTree_Y_DC)
        != ippStsNoErr) throw mxcpcDidntWorkOutException();
    if(ippiDecodeHuffmanSpecInit_JPEG_8u(&DefaultHuffmanTable_Y_AC[0],
                                         &DefaultHuffmanTable_Y_AC[16],
                                         HuffmanTree_Y_AC)
        != ippStsNoErr) throw mxcpcDidntWorkOutException();
    if(ippiDecodeHuffmanSpecInit_JPEG_8u(&DefaultHuffmanTable_UV_DC[0],
                                         &DefaultHuffmanTable_UV_DC[16],
                                         HuffmanTree_UV_DC)
        != ippStsNoErr) throw mxcpcDidntWorkOutException();
    if(ippiDecodeHuffmanSpecInit_JPEG_8u(&DefaultHuffmanTable_UV_AC[0],
                                         &DefaultHuffmanTable_UV_AC[16],
                                         HuffmanTree_UV_AC)
        != ippStsNoErr) throw mxcpcDidntWorkOutException();
             
    if(ippiEncodeHuffmanSpecInit_JPEG_8u(&DefaultHuffmanTable_Y_DC[0],
                                         &DefaultHuffmanTable_Y_DC[16],
                                         HuffmanEncodeSpec_Y_DC)
        != ippStsNoErr) throw mxcpcDidntWorkOutException();
    if(ippiEncodeHuffmanSpecInit_JPEG_8u(&DefaultHuffmanTable_Y_AC[0],
                                         &DefaultHuffmanTable_Y_AC[16],
                                         HuffmanEncodeSpec_Y_AC)
        != ippStsNoErr) throw mxcpcDidntWorkOutException();
    if(ippiEncodeHuffmanSpecInit_JPEG_8u(&DefaultHuffmanTable_UV_DC[0],
                                         &DefaultHuffmanTable_UV_DC[16],
                                         HuffmanEncodeSpec_UV_DC)
        != ippStsNoErr) throw mxcpcDidntWorkOutException();
    if(ippiEncodeHuffmanSpecInit_JPEG_8u(&DefaultHuffmanTable_UV_AC[0],
                                         &DefaultHuffmanTable_UV_AC[16],
                                         HuffmanEncodeSpec_UV_AC)
        != ippStsNoErr) throw mxcpcDidntWorkOutException();
        
  } catch(mxcpcDidntWorkOutException) {
  
      std::free(HuffmanTree_Y_DC);
      std::free(HuffmanTree_Y_AC);
      std::free(HuffmanTree_UV_DC);
      std::free(HuffmanTree_UV_AC);
      std::free(HuffmanEncodeSpec_Y_DC);
      std::free(HuffmanEncodeSpec_Y_AC);
      std::free(HuffmanEncodeSpec_UV_DC);
      std::free(HuffmanEncodeSpec_UV_AC);
      
      throw;
    }
    
  for(i = 0; i < 64; i++) {
    QuantizationTable_Y[i]  = 0;
    QuantizationTable_UV[i] = 0;
  }
  
  CoeffBuffer = 0;
  TileNumX = TileNumY = 0;
  
  FramesProcessed = 0;
  
  
  // init APP0 - taken from Klaus' jp-hdr.c (20050422)...
  APP0_Block.ff          = 0xff;
  APP0_Block.app0_marker = mxcpc_mxpeg::MarkerId_APP0;
  APP0_Block.len_hi      = (sizeof(mxcpc_mxpeg::APP0) - 2) / 256;
  APP0_Block.len_lo      = (sizeof(mxcpc_mxpeg::APP0) - 2) % 256;
  std::strcpy(APP0_Block.id, "JFIF"); 
  APP0_Block.major_vers  = 0x01; 
  APP0_Block.minor_vers  = 0x01;
  APP0_Block.units       = 0x00;
  APP0_Block.xdpu_hi     = 0;
  APP0_Block.xdpu_lo     = 1;
  APP0_Block.ydpu_hi     = 0;
  APP0_Block.ydpu_lo     = 1;
  APP0_Block.thumbnail_x = 0;
  APP0_Block.thumbnail_y = 0;
  
  // init SOF0, image size is zeroed out...
  SOF0_Block.ff                         = 0xff;
  SOF0_Block.marker                     = mxcpc_mxpeg::MarkerId_SOF0;
  SOF0_Block.len_hi                     = (sizeof(mxcpc_mxpeg::SOF0) - 2) / 256;
  SOF0_Block.len_lo                     = (sizeof(mxcpc_mxpeg::SOF0) - 2) % 256;
  SOF0_Block.data_precision             = 0x08;
  SOF0_Block.y_sz_hi                    = 0;
  SOF0_Block.y_sz_lo                    = 0;
  SOF0_Block.x_sz_hi                    = 0;
  SOF0_Block.x_sz_lo                    = 0;
  SOF0_Block.num_components             = 3;
  SOF0_Block.components[0].component_id = 1;   // Y
  SOF0_Block.components[0].sampl_fact   = 0x22;
  SOF0_Block.components[0].quant_tbl_no = 0;
  SOF0_Block.components[1].component_id = 2;   // U
  SOF0_Block.components[1].sampl_fact   = 0x11;
  SOF0_Block.components[1].quant_tbl_no = 1;
  SOF0_Block.components[2].component_id = 3;   // V
  SOF0_Block.components[2].sampl_fact   = 0x11;
  SOF0_Block.components[2].quant_tbl_no = 1;
  
  // init SOF0, image size is zeroed out...
  SOS_Block.ff                    = 0xff;
  SOS_Block.sos_marker            = mxcpc_mxpeg::MarkerId_SOS;
  SOS_Block.sz_hi                 = (sizeof(mxcpc_mxpeg::SOS) - 2) / 256;
  SOS_Block.sz_lo                 = (sizeof(mxcpc_mxpeg::SOS) - 2) % 256;
  SOS_Block.comps_in_scan         = 3;
  SOS_Block.components[0].comp_id = 1;
  SOS_Block.components[0].td_ta   = 0x00;
  SOS_Block.components[1].comp_id = 2;
  SOS_Block.components[1].td_ta   = 0x11;
  SOS_Block.components[2].comp_id = 3;
  SOS_Block.components[2].td_ta   = 0x11;
  SOS_Block.Ss                    = 0x00;
  SOS_Block.Se                    = 0x3f;
  SOS_Block.Ah_Al                 = 0x00;
}   


mxcpcFramewiseMxPEGScanToJPEGConverterIPP
 ::~mxcpcFramewiseMxPEGScanToJPEGConverterIPP() {

  std::free(HuffmanTree_Y_DC);
  std::free(HuffmanTree_Y_AC);
  std::free(HuffmanTree_UV_DC);
  std::free(HuffmanTree_UV_AC);
  std::free(HuffmanEncodeSpec_Y_DC);
  std::free(HuffmanEncodeSpec_Y_AC);
  std::free(HuffmanEncodeSpec_UV_DC);
  std::free(HuffmanEncodeSpec_UV_AC);
  
  delete[] CoeffBuffer;
}   



const char *mxcpcFramewiseMxPEGScanToJPEGConverterIPP
            ::getAccelerationTypeString(void) {
                    
  return("Intel Performance Primitives");
}


void mxcpcFramewiseMxPEGScanToJPEGConverterIPP::setYQuantizationTable(
                                                 unsigned char *data_bytes) {

  ippiQuantInvTableInit_JPEG_8u16u(data_bytes,
                                   QuantizationTable_Y);
}

 
void mxcpcFramewiseMxPEGScanToJPEGConverterIPP::setUVQuantizationTable(
                                                 unsigned char *data_bytes) {

  ippiQuantInvTableInit_JPEG_8u16u(data_bytes,
                                   QuantizationTable_UV);
}


void mxcpcFramewiseMxPEGScanToJPEGConverterIPP
      ::performScanSweep(mxcpcFramewiseMxPEGDecoder::UndecodedFrameDescriptor 
                          *frame_descriptor)                                  {
                          
  // init some local data facilitating invocation of the IPP routines...
  //   done only once for an entire scan sweep, so we can do this here on the
  //   stack...
  const IppiDecodeHuffmanSpec *dc_huffman_trees[6] = { HuffmanTree_Y_DC,
                                                       HuffmanTree_Y_DC,
                                                       HuffmanTree_Y_DC, 
                                                       HuffmanTree_Y_DC,
                                                       HuffmanTree_UV_DC, 
                                                       HuffmanTree_UV_DC,                                      
                                                     };    
  const IppiDecodeHuffmanSpec *ac_huffman_trees[6] = { HuffmanTree_Y_AC,
                                                       HuffmanTree_Y_AC,
                                                       HuffmanTree_Y_AC, 
                                                       HuffmanTree_Y_AC,
                                                       HuffmanTree_UV_AC, 
                                                       HuffmanTree_UV_AC,                                      
                                                     };
  const IppiEncodeHuffmanSpec *dc_huffman_encode_specs[6] = { HuffmanEncodeSpec_Y_DC,
                                                              HuffmanEncodeSpec_Y_DC,
                                                              HuffmanEncodeSpec_Y_DC,
                                                              HuffmanEncodeSpec_Y_DC,
                                                              HuffmanEncodeSpec_UV_DC,
                                                              HuffmanEncodeSpec_UV_DC,
                                                            };
  const IppiEncodeHuffmanSpec *ac_huffman_encode_specs[6] = { HuffmanEncodeSpec_Y_AC,
                                                              HuffmanEncodeSpec_Y_AC,
                                                              HuffmanEncodeSpec_Y_AC,
                                                              HuffmanEncodeSpec_Y_AC,
                                                              HuffmanEncodeSpec_UV_AC,
                                                              HuffmanEncodeSpec_UV_AC,
                                                            };
  Ipp16s last_y_dc = 0, last_u_dc = 0, last_v_dc = 0;
  Ipp16s *last_dc_ptrs[6] = { &last_y_dc, &last_y_dc, &last_y_dc, &last_y_dc,
                              &last_u_dc, &last_v_dc
                            };
  int detected_marker = 0;
  Ipp32u prefetched_bits = 0;
  int prefetched_bit_num = 0;
  int pos = 0;
  Ipp8u bitstream_buffer[MXCPC_FRAMEWISEMXPEGSCANTOJPEGCONVERTERIPP_BITSTREAM_BUFFSIZE];
  int bitstream_pos = 0;
  
  // remaining local data...
  IppStatus ipp_status;
  bool use_bitmask;
  int tilebits_left;
  unsigned char *tilebit_ptr, tilebit_mask;
  int x, y;
  bool next_tile_right_here;
  int tiles_to_write;
  Ipp16s *sub_mcu_coeffs;
  mxcpc::u8 quantization_table_to_write[64];
  Ipp16u *quant_coeff;
  const unsigned char *huffman_table_to_write;
  int                  huffman_table_to_write_size;
  int i, j;
  
  mxcpc::u8 write_buffer[10];
    
  
  // guard against missing backend
  if(!BackEnd) return;
  
  
  // check coeff buffer and its dimensions...
  if(   (frame_descriptor->TileNumX != TileNumX)
     || (frame_descriptor->TileNumY != TileNumY)) {
  
    delete[] CoeffBuffer;
    
    try {
    
      CoeffBuffer = new Ipp16s[frame_descriptor->TileNumX * frame_descriptor->TileNumY
                                * 6 * 64];
      TileNumX = frame_descriptor->TileNumX;
      TileNumY = frame_descriptor->TileNumY;
      
      mxcpc::sendStatusMsg("JPG converter : reallocated coeff buffer");
                                
    } catch(std::bad_alloc) {
      
        CoeffBuffer = 0;
        TileNumX = TileNumY = 0;
      }
  }  
  if(!CoeffBuffer) {
    BackEnd->errorEncountered();
    return;
  } 
      
    
  // decide for bitmask mode...
  tilebits_left = frame_descriptor->TileNumX * frame_descriptor->TileNumY;
  tilebit_ptr   = frame_descriptor->TileBits;
  tilebit_mask  = 128;
  x = -1;
  y = 0;
  ipp_status = ippStsNoErr;
  next_tile_right_here = true;   // default for bitmask-less mode
  if(tilebit_ptr) 
    use_bitmask = true;
  else
    use_bitmask = false;
   
    
  // iterate over all tiles (MCUs)...
  while(tilebits_left) {
  
    // advance target tile coordinates...
    x++;
    if(x == frame_descriptor->TileNumX) {
      x = 0;
      y++;
    }
  
    // if in bitmask mode, consume and honor current tile bit...
    if(use_bitmask) {
      next_tile_right_here = (*tilebit_ptr & tilebit_mask) != 0;
      tilebit_mask /= 2;
      if(!tilebit_mask) {
        tilebit_mask = 128;
        tilebit_ptr++;
      }
    }
   
    if(next_tile_right_here) {   // decode tile...
      
      // iterate over the 6 sub-MCUs (Y,Y,Y,Y,U,V)...
      for(i = 0; i < 6; i++) {
       
        if(ipp_status != ippStsNoErr) {   // decoding of previous sub-MCU caused
                                          // an error - better stop...
          BackEnd->errorEncountered();
          return;
        }
        
        ipp_status = ippiDecodeHuffman8x8_Direct_JPEG_1u16s_C1(
                      frame_descriptor->ScanBytes, &pos,
                      &CoeffBuffer[y * TileNumX * 6*64  +  x * 6*64  +  i * 64],
                      last_dc_ptrs[i],
                      &detected_marker,
                      &prefetched_bits, &prefetched_bit_num,
                      dc_huffman_trees[i], ac_huffman_trees[i]);
      }
      
      // got all 6 sub-MCUs!
            
      BackEnd->videoTileReceived();
    } 
    
    tilebits_left--;
  }
  
  // ok, got a frame...
  
  Receiver->beginFrame();
  
  // write SOI...
  write_buffer[0] = 0xff;
  write_buffer[1] = mxcpc_mxpeg::MarkerId_SOI;
  Receiver->receiveJPEGBytes(write_buffer, 2);
  
  // write APP0...
  Receiver->receiveJPEGBytes((mxcpc::u8 *)&APP0_Block, 
                             sizeof(mxcpc_mxpeg::APP0));
  
  // write quantization tables, Y(0) and UV(1)...
  for(i = 0; i < 2; i++) {   // got two of them
    
    write_buffer[0] = 0xff;
    write_buffer[1] = mxcpc_mxpeg::MarkerId_DQT;
    write_buffer[2] = 0;
    write_buffer[3] = 67;
    write_buffer[4] = i;
    Receiver->receiveJPEGBytes(write_buffer, 5);
  
    if(!i) quant_coeff = QuantizationTable_Y;
    else   quant_coeff = QuantizationTable_UV;
    for(j = 0; j < 64; j++) 
      quantization_table_to_write[ZigZag_StoreMap[j]] = *quant_coeff++;
    Receiver->receiveJPEGBytes(quantization_table_to_write, 64);
  }
  
  // write SOF0...
  SOF0_Block.x_sz_hi = frame_descriptor->Width / 256;
  SOF0_Block.x_sz_lo = frame_descriptor->Width % 256;
  SOF0_Block.y_sz_hi = frame_descriptor->Height / 256;
  SOF0_Block.y_sz_lo = frame_descriptor->Height % 256;
  Receiver->receiveJPEGBytes((mxcpc::u8 *)&SOF0_Block, 
                             sizeof(mxcpc_mxpeg::SOF0));
  
  // write huffman tables...
  for(i = 0; i < 4; i++) {   // got four of them
  
    write_buffer[0] = 0xff;
    write_buffer[1] = mxcpc_mxpeg::MarkerId_DHT;
    if(i == 0) {
      write_buffer[4] = 0x00;
      huffman_table_to_write      = DefaultHuffmanTable_Y_DC;
      huffman_table_to_write_size = DefaultHuffmanTable_Y_DC_Size;
    }
    else if(i == 1) {
      write_buffer[4] = 0x10;
      huffman_table_to_write      = DefaultHuffmanTable_Y_AC;
      huffman_table_to_write_size = DefaultHuffmanTable_Y_AC_Size;
    }
    else if(i == 2) {
      write_buffer[4] = 0x01;
      huffman_table_to_write      = DefaultHuffmanTable_UV_DC;
      huffman_table_to_write_size = DefaultHuffmanTable_UV_DC_Size;
    }
    else {
      write_buffer[4] = 0x11;
      huffman_table_to_write      = DefaultHuffmanTable_UV_AC;
      huffman_table_to_write_size = DefaultHuffmanTable_UV_AC_Size;
    }
    write_buffer[2] = (huffman_table_to_write_size + 3) / 256;
    write_buffer[3] = (huffman_table_to_write_size + 3) % 256;
  
    Receiver->receiveJPEGBytes(write_buffer, 5);
    Receiver->receiveJPEGBytes((mxcpc::u8 *)huffman_table_to_write, 
                               huffman_table_to_write_size);
  }  
  
  // write SOS...
  Receiver->receiveJPEGBytes((mxcpc::u8 *)&SOS_Block, 
                             sizeof(mxcpc_mxpeg::SOS));
  
  // write out scan...
  last_y_dc = last_u_dc = last_v_dc = 0;
  sub_mcu_coeffs = CoeffBuffer;
  bitstream_pos  = 0;
  tiles_to_write = TileNumX * TileNumY;
  while(tiles_to_write) {
  
    // iterate over sub-MCUs of current tile...
    for(i = 0; i < 6; i++) {
         
      ippiEncodeHuffman8x8_Direct_JPEG_16s1u_C1(sub_mcu_coeffs,
                                                bitstream_buffer,
                                                &bitstream_pos,
                                                last_dc_ptrs[i],
                                                dc_huffman_encode_specs[i],
                                                ac_huffman_encode_specs[i]);
  
      if(bitstream_pos >= 8) {
        
        Receiver->receiveJPEGBytes(bitstream_buffer, bitstream_pos/8);
                                                                                              
        // copy down partially filled byte at the end...
        bitstream_buffer[0] = bitstream_buffer[bitstream_pos/8];
        bitstream_pos = bitstream_pos % 8;
      }
                                                 
      sub_mcu_coeffs += 64;
    }
    
    tiles_to_write--;
  }
  
  // deal with last byte
  Receiver->receiveJPEGBytes(bitstream_buffer, 1);   // pad unused bits?
  
  // write EOI...
  write_buffer[0] = 0xff;
  write_buffer[1] = mxcpc_mxpeg::MarkerId_EOI;
  Receiver->receiveJPEGBytes(write_buffer, 2);
   
  Receiver->endFrame();
  // TODO : forward error from converter backend to decoder backend
  
  FramesProcessed++;
}